package com.b_noble.n_life.event;

/**
 * 公司：深圳市中泰智丰物联网科技有限公司
 * 项目：智能家居
 * 简述：控制类型枚举类
 * 作者：zhangfan
 * 时间：2016-08-02
 * 版本：V0.0.1
 */
public enum ControlTypeEnum {

	/**
	 * 获取当前所有设备
	 */
	GET_DEVICE(0x86),
	
	/**
	 * 上报新设备
	 */
	REPORT_NEW_DEVICE(0X87),
	
	/**
	 * 发送心跳包
	 */
	SEND_HEARTBEAT(0X88),
	
	/**
	 * 设置指定设备开关状态
	 */
	SET_DEVICE_STATE(0x8E),
	
	/**
	 * 设置指定设备的亮度
	 */
	SET_DEVICE_LEVEL(0x90),
	
	/**
	 * 设置指定设备颜色
	 */
	SET_DEVICE_COLOR(0x92),
	
	/**
	 * 获取指定设备的开关状态
	 */
	GET_DEVICE_STATE(0x8F),
	
	/**
	 * 获取指定设备的亮度
	 */
	GET_DEVICE_LEVEL(0X91),
	
	/**
	 * 获取指定设备的色调
	 */
	GET_DEVICE_HUE(0X93),
	
	/**
	 * 获取指定设备的饱和度
	 */
	GET_DEVICE_SATURATION(0X88),
	
	/**
	 * 获取指定设备色温
	 */
	GET_DEVICE_COLORTEMPERATURE(0x95),
	
	/**
	 * 绑定设备
	 */
	BIND_DEVICE(0X89),
	
	/**
	 * 获取场景成员
	 */
	GET_SENCE_MEMBER(0XAD),
	
	/**
	 * 删除场景成员
	 */
	//DELETE_SENCE_MEMBER(0XAB),
	
	/**
	 * 修改场景名称
	 */
	UPDATE_SENCE_NAME(0XAE),
	
	/**
	 * 获取组
	 */
	GET_GROUP(0X8E),
	
	/**
	 * 添加指定设备到组
	 */
	ADD_DEVICE_GROUP(0X8F),
	
	/**
	 * 获取场景
	 */
	GET_SENCE(0XAC),
	
	/**
	 * 添加场景
	 */
	ADD_SENCE(0XAA),
	
	/**
	 * 添加设备到场景
	 */
	//ADD_DEVICE_SENCE(0xAB),
	/**
	 * 修改场景
	 */
	MODITY_SCENE(0xAB),
	
	/**
	 * 调用场景
	 */
	RECALL_SENCE(0XB0),
	
	/**
	 * 删除场景
	 */
	DELETE_SENCE(0XAF),
	
	/**
	 * 更改指定设备名
	 */
	UPDATE_DEVICE_NAME(0X8D),
	
	/**
	 * 删除指定设备
	 */
	DELETE_DEVICE(0X8C),
	
	/**
	 * 取消绑定
	 */
	UNBIND_DEVICE(0X96),
	
	/**
	 * 从组中删除指定设备
	 */
	DELTEE_DEVICE_GROUP(0X97),
	
	/**
	 * 获取组成员名单
	 */
	GET_GROUP_MEMBER(0X98),
	
	/**
	 * 获取定时任务
	 */
	GET_TIMERTASK(0X99),
	
	/**
	 * 添加定时任务
	 */
	ADD_TIMERTASK(0X9A),
	
	/**
	 * 获取指定场景的任务
	 */
	GET_TASK_SCENE(0Xff),
	
	/**
	 * 获取指定设备任务
	 */
	GET_TASK_DEVICE(0xff),
	/**
	 * 更新任务状态
	 */
	UPDATE_TASK_STATE(0xB9),
	
	GET_TIMER_TASK(0xBA),
	
	/**
	 * 获取指定设备的联动任务
	 */
	GET_TASK_UID(0Xff),
	
	/**
	 * 删除定时任务
	 */
	DELETE_TIMERTASK(0X9B),
	
	/**
	 * 修改任务
	 */
	UPDATE_TASK(0XBB),
	
	/**
	 * 获取网关信息
	 */
	GET_GATEWAY_INFO(0X80),
	
	/**
	 * 设置传感器上报时间
	 */
	SET_SENSOR_TIME(0X9E),
	
	/**
	 * 允许入网
	 */
	ALLOW_NET(0X82),
	
	/**
	 * 打开/关闭在线查询
	 */
	UPDATE_NETQUERY_STATE(0XA0),
	
	/**
	 * 复位网关
	 */
	RESET_GATEWAY(0XA1),
	
	/**
	 * 0xA2 获取 RSSI
	 */
	GET_RSSI(0XA2),
	
	/**
	 * 增加任务
	 */
	ADD_TASK(0XB5),
	
	/**
	 * 删除任务
	 */
	DELETE_TASK(0XB6),
	/**
	 * 修改任务
	 */
	MODITY_TASK(0XB7),
	
	/**
	 * 修改任务名称
	 */
	UPDATE_TASK_NAME(0xb8),
	
	/**
	 * 查看任务详情
	 */
	GET_TASK_INFO(0XBC),
	
	/**
	 * 获取所有任务
	 */
	//GET_ALL_TASK(0XB8),
	
	/**
	 * 红外相关
	 */
	IR_RELEVANT(0XA7),
	
	/**
	 * 设置设备色温
	 */
	SET_COLOR_TEMPERATURE(0X94),
	
	/**
	 * 获取设备色温
	 */
	GET_COLOR_TEMPERATURE(0XA9),
	
	/**
	 * 对网关中一字符串信息操作
	 */
	OPER_GATEWAY_STRING(0XAB),
	
	/**
	 * cie相关指令
	 */
	CIE_RELEVANT(0XAC),
	
	/**
	 * 网关和 ZigBee 信息相关
	 */
	GATEWAY_ZIGBEE_RELEVANT(0XAE),
	
	/**
	 * 修改组名
	 */
	UPDATE_GROUP_NAME(0XAF),
	
	/**
	 * 添加联动任务
	 */
	ADD_LINKAGE_TASK(0XC0),
	
	/**
	 * 查询联动任务详细
	 */
	GET_LINKAGE_TASK_DETAILS(0XBF),
	
	/**
	 * 查询所有联动任务
	 */
	QUERY_ALL_LINKAGE(0xbe),
	
	QUERY_LINKAGE_UID(0xbd),
	
	/**
	 * 删除联动任务
	 */
	DELETE_LINKAGE_TASK(0XC1),
	
	MODITY_LINKAGE_TASK(0xC2),
	
	UPDATE_LINKAGE_NAME(0xc3),
	
	UPDATE_LINKAGE_STATUS(0xc4),
	
	/**
	 * 查询指定场景的联动任务
	 */
	GET_LINKAGE_SCENE(0Xff),
	/**
	 * 查询指定设备的联动任务
	 */
	GET_LINKAGE_DEVICE(0Xff),
	
	/**
	 * 添加区域
	 */
	ADD_AREA(0xC5),
	/**
	 * 查询区域详细
	 */
	GET_AREA_DETAILS(0xC6),
	/**
	 * 删除区域
	 */
	DELETE_AREA(0XC7),
	/**
	 * 获取所有区域
	 */
	GET_ALL_AREA(0XC8),
	
	/**
	 * 登录验证指令
	 */
	LOGIN_VALODATE(0xDF),
	/**
	 * 验证管理密码
	 */
	VERIFICATION_MANAGERPWD(0xCB),
	/**
	 * 查询密码
	 */
	QUERY_PASSWORD(0xCC),
	/**
	 * 修改登录密码
	 */
	MODIFY_LOGIN_PASSWORD(0XCD),
	
	/**
	 * 修改管理密码
	 */
	MODIFY_MANAGE_PASSWORD(0XCE),
	/**
	 * 局域网登录网关
	 */
	LOGIN_GA_LAN(0xCA),
	/**
	 * 绑定网关
	 */
	BING_GA(0xD2),
	/**
	 * 添加用户
	 */
	ADD_USER_GA(0XD3),
	/**
	 * 设置窗帘电机方向
	 */
	SET_ELECTRIC_MOTOR_DIRECTION(0X96),
	
	/**
	 * 配置窗帘电机
	 */
	CONFIGURATION_ELECTRIC_MOTOR(0X97),
	
	/**
	 * 查询窗帘电机配置信息
	 */
	QUERY_ELECTRIC_INFO(0X98),
	
	/**
	 * 查询窗帘电机状态
	 */
	QUERY_MOTOR_STATUS(0X99),
	/**
	 * 打开或关闭窗帘
	 */
	OPEN_OR_CLOSE_CURTAIN(0X9A),
	
	/**
	 * 停止操作窗帘
	 */
	STOP_OPERATING_CURTAIN(0X9B),
	/**
	 * 打开或关闭窗帘
	 */
	QUERY_CURTAIN_POSITION(0X9C),
	
	CURTAIN_STROKE_CONTROL(0x9d),
	
	DELETE_STROKE(0x9e),
	
	/**
	 * 设置门锁开关状态
	 */
	SET_DOORLOCK_SWITCH_STATE(0x70),
	
	/**
	 * 查询门锁开关状态
	 */
	QUERY_DOORLOCK_SWITCH_STATE(0x71),
	
	QUERY_DOORLOCK_ELECTRICITY(0x72),
	
	/**
	 * 操作门锁通知
	 */
	OPERATION_EVENT_NOTIFICATION(0X73),
	ABNORMAL_EVENT_NOTIFICATION(0x74),
	
	/**
	 * 设置门锁用户
	 */
	SET_USER_NAME(0x75),
	
	QUERY_USER_INFO(0x76),
	
	/**
	 * 设置门锁权限
	 *//*
	SET_PERMISSION_DOORLOCK(0x73),
	
	*//**
	 * 查询门锁权限
	 *//*
	QUERY_PERMISSION_DOORLOCK(0x74),*/
	 
	 
	
	/**
	 * 添加用户到门锁
	 */
	ADD_USER_TO_DOORLOCK(0X77),
	
	/**
	 * 删除用户到门锁
	 */
	DELETE_USER_TO_DOORLOCK(0X78),
	
	QUERY_UNLOCK_RECORD(0x79),
	DELETE_UNLOCK_RECORD(0x7a),
	
	QUERY_UNLOCK_RECORD_BY_TIME(0x7b),
	
	QUERY_ABNORMAL_RECORD(0x7c),
	
	QUERY_ABNORMAL_RECORD_BY_TIME(0x7d),
	
	DELETE_ABNORMAL_RECORD(0xa7),
	
	FREEZE_LOCK_USER_PASSWORD(0xa8),
	
	QUERY_LOCK_MACHINE_CODE(0xa9),
	
	SET_THE_LOCK_TIME(0x00),
	
	
	DELETE_USER_FROM_GATEWAY(0xd5),
	
	REQUEST_GATE_ZIGBEE_VERSION(0X7F),
	
	RESET_GATE(0x83),
	
	REPORT_UPGRADE_STATUS(0x7e),
	
	DEVICE_KEY_CONFIGURE(0x6a),
	
	DELETE_CONFIGURE_OF_DEVICEKEY(0x6b),
	
	QUERY_ALL_CONFIGURE_OF_THE_DEVICE(0x6c),
	
	SET_THE_THERMOSTAT_MODE(0x60),
	
	SET_THE_WIND_SPEED(0x61),
	
	ADJUSTT_THE_TEMPERATURE(0x62),
	
	SET_THE_RUN_MODE_THAT_POWERRESUME(0x63),
	
	QUERY_THE_THERMOSTAT_CONFIGUREINFO(0x67),
	
	QUERY_THE_THERMOSTAT_RUN_STATUS(0x65),
	
	SET_THE_THERMOSTAT_STATE(0x66),
	
	//QUERY_OPERATION_PERMISSION_BY_USERNAME(0x50),
	
	SET_DOORLOCK_SWITCHSTATE(0X50),
	
	QUERY_GYDOORLOCK_SWITCHSTATE(0x51),
	
	CONFIGURE_DOORLOCK_NORMALOPEN(0x52),
	
	QUERY_DOORLOCK_RECENT_STATUS(0x53),
	
	ADD_GYDOORLOCK_USER(0x54),
	
	DELETE_GYDOORLOCK_USER(0x55),
	
	FREEZE_DOORLOCK_USER(0x56),
	
	MODIFY_DOORLOCK_USER_ALIAS(0x57),
	
	MODIFY_DOORLOCK_USER_PASSWD(0x58),
	
	QUERY_ALL_LOCKUSER_INFO(0x59),
	
	DOORLOCK_EVENT_PUSH(0x5e),
	
	BIND_DDEVICE(0x68),
	
	CANCEL_BIND(0x69),
	
	QUERY_ALL_BIND(0x6d),
	
	QUERY_ALARM_RECORDS(0x4e),
	
	DELETE_ALARM_RECORDS(0x4f),
	
	DEVICE_EMERGENCY_ALARM_PUSH(0xA3),
	
	GET_K1_DEVICE_STATES(0x4d),
	
	REPORT_K1_STATE(0x4c),
	
	REPORT_K1_ABNORMAL(0x4b),
	
	GET_K1_KEYS_ID(0x4a),
	
	GET_K1_MEMBER(0x49),
	
	ADD_K1_MEMBER(0x48),
	
	DELETE_K1_MEMBER(0x47),
	
	UPDATE_K1_MEMBER_NAME(0x46),
	
	GET_K1_MEMBER_INFO(0x45),
	
	ADD_K1_KEY(0x44),
	
	REPORT_FINGERPRINT_STATE(0x43),
	
	DETETE_K1_KEY(0x42),
	
	UPDATE_K1_PASSWORD(0x41),
	
	UPDATE_K1_FINGERPRINT_NAME(0x40),
	
	GET_K1_RECORD_LIST(0x3f),
	
	DELETE_K1_RECORD(0x3e),
	
	RELIEVE_ALARM(0x3d),
	
	ADD_K1_TEM_PASSWORD(0x3c),
	
	DELETE_K1_TEM_PASSWORD(0x3b),
	
	GET_K1_TEM_PASSWORK_LIST(0x3a),
	
	DELETE_TEM_PASSWORD_RECORDS(0x39),
	
	REPORT_HIJACK(0x38),
	
	GET_K1_INFOS(0x37),
	
	UPGRADE_K1_REQUEST(0x36),
	
	REPORT_UPGRADE_K1(0x35),
	VILIDATE_K1_PWD(0x34),
	
	CONFIGUR_WIFI_INFO(0x84),
	
	SEARCH_WIFI(0x85),
	
	REPORT_UPGRADE_SPEED(0x33),
	
	SET_3D_MODULE(0x32),
	
	QUERY_3D_MODULE(0x64),
	
	GET_K1_RECORD_LIST_3D(0x9f),
	;
	
	private int v;
	
	private ControlTypeEnum(int v) {

        this.v = v;
    }

    public int getVal() {
        return v;
    }

    public static ControlTypeEnum valuesOf(int e) {
    	ControlTypeEnum[] vs = ControlTypeEnum.values();
        if (vs == null || vs.length == 0) {
            return null;
        }
        for (ControlTypeEnum event : vs) {
            if (event.getVal() == e) {
                return event;
            }
        }
        return null;
    }
}
