package com.b_noble.n_life.event;
/**
 * 公司：深圳市中泰智丰物联网科技有限公司
 * 项目：智能家居
 * 简述：添加联动任务时的设备对照表
 * 作者：zhangfan
 * 时间：2016-11-12
 * 版本：V0.0.1
 */
public enum DevTypeEnum {

	/**
	 * 灯
	 */
	LIGTH(1),
	
	/**
	 * 插座
	 */
	OUTLET(2),
	
	/**
	 * 门磁
	 */
	MAGNETIC(3),
	
	/**
	 * 红外
	 */
	INFRARED (4),
	
	/**
	 * 水浸
	 */
	FLOODING (5),
	
	/**
	 * 烟雾
	 */
	SMOKE (6),
	
	/**
	 * 一氧化碳
	 */
	CO (7),
	/**
	 * 燃气
	 */
	GAS (8),
	
	TEMPERATURE (9),
	
	HUMIDITY (10);
	
	;
	
	
	
	
	private int v;
	
	private DevTypeEnum(int v) {

        this.v = v;
    }

    public int getVal() {
        return v;
    }

    public static DevTypeEnum valuesOf(int e) {
    	DevTypeEnum[] vs = DevTypeEnum.values();
        if (vs == null || vs.length == 0) {
            return null;
        }
        for (DevTypeEnum event : vs) {
            if (event.getVal() == e) {
                return event;
            }
        }
        return null;
    }
}
