package com.b_noble.n_life.event;

/**
 * 公司：深圳市中泰智丰物联网科技有限公司
 * 项目：智能家居
 * 简述：设备类型枚举类
 * 作者：zhangfan
 * 时间：2016-08-02
 * 版本：V0.0.1
 */
public enum DeviceTypeEnum {

	/**
	 * 未知设备
	 */
	UNKNOWN(-1),
	/**
	 * RGB彩灯
	 */
	RGB_LIGTH(1),
	/**
	 * CT灯
	 */
	CT_LIGTH(8),
	
	/**
	 * 传感器
	 */
	SENSOR(2),
	/**
	 * 温度湿度传感器
	 */
	TEMPERATURE_HUMIDITY(3),
	
	
	/**
	 * 电源插座
	 */
	MAINSPOWEROUTLET(5),
	/**
	 * 智能插座
	 */
	ZMAINSPOWEROUTLET(6),
	
	/**
	 * 开关面板
	 */
	MECHANICALHANDLE(7),
	/**
	 * 窗帘
	 */
	CURTAIN(9),
	
	/**
	 * 智能门锁
	 */
	DOORLOCK(10) ,
	
	/**
	 * 红外遥控器
	 */
	IR(11),
	
	IR_REMOTE_CONTROL(12),
	
	/**
	 * 情景面板
	 */
	SCENE_PANEL(13),
	
	/**
	 * 温控器
	 */
	THERMOSTAT(14),
	
	/**
	 * 窗帘面板
	 */
	CURTAIN_PANEL(15),
	
	/**
	 * 报警器
	 */
	ALARM(16),
	
	;
	
	private int v;
	
	private DeviceTypeEnum(int v) {

        this.v = v;
    }

    public int getVal() {
        return v;
    }

    public static DeviceTypeEnum valuesOf(int e) {
    	DeviceTypeEnum[] vs = DeviceTypeEnum.values();
        if (vs == null || vs.length == 0) {
            return null;
        }
        for (DeviceTypeEnum event : vs) {
            if (event.getVal() == e) {
                return event;
            }
        }
        return null;
    }
}
