package com.b_noble.n_life.event;

/**
 * 公司：深圳市中泰智丰物联网科技有限公司
 * 项目：智能家居
 * 简述：ir控制类型枚举类
 * 作者：zhangfan
 * 时间：2016-08-02
 * 版本：V0.0.1
 */
public enum IrControlTypeEnum {

	/**
	 * 获取遥控器信息
	 */
	GET_REMOTECONTROL_INFORMATION(0x80),
	/**
	 * 设置wifi信息
	 */
	SET_WIFI_NETWORK_INFORMATION(0x81),
	/**
	 * 获取wifi信息
	 */
	REQUEST_WIFI_NETWORK_INFORMATION(0x82),
	/**
	 * 重置遥控器
	 */
	RESET_REMOTE_CONTROL(0x83),
	/**
	 * 获取所有红外设备
	 */
	QUIRYIR_ALL_DEVICE(0X85),
	
	/**
	 * 上报新设备
	 */
	 REPORT_NEW_DEVICE(0x86),
	
	/**
	 * 获取指定设备信息
	 */
	REQUEST_DEVICE_INFORMATION(0x8A),
	
	/**
	 * 移除红外设备
	 */
	REMOVE_IR_DEVICE(0X8B),
	
	/**
	 * 更新遥控器名称
	 */
	UPDATE_DEVICE_NAME(0X8C),
	
	/**
	 * 设置设备开关状态
	 */
	SET_DEVICE_SWITCH_STATE(0X8d),
	
	/**
	 * 获取指定设备的开关状态
	 */
	GET_DEVICE_SWITCH_STATE(0X8E),
	
	/**
	 * 设置灯的亮度
	 */
	SET_LIGHT_BRIGHTNESS(0X8F),
	/**
	 * 获取灯的亮度
	 */
	GET_LIGHT_BRIGHTNESS(0X90),
	
	/**
	 * 设置灯的色调饱和度
	 */
	SET_LIGHTHUE_OR_SATURATION(0X91),
	
	/**
	 * 获取灯的色调饱和度
	 */
	GET_LIGHTHUE_OR_SATURATION(0X92),
	/**
	 * 发送红外码
	 */
	REQUIRE_REMOTE_CONTROL_INFRARED_CODE(0x93),
	
	REQUEST_TEMPERATURE_INFORMATION(0x95),
	REQUEST_HUMIDITY_INFORMATION(0x96),
	
	/**
	 * 添加联动任务
	 */
	ADD_LINKAGE(0xa8),
	QUERY_LINKAGE_DETAILS(0xa9),
	QUERY_ALL_LINKAGE(0xaa),
	DELETE_LINKAGE(0xab),
	
	/**
	 * 设置灯的感应模式
	 */
	SET_LAMP_SENSING_MODE(0xad),
	
	/**
	 *   设置灯光流光溢彩的模式
	 */
	SET_LIGHT_AMBILIGHT_MODE(0xAE),
	
	
	/**
	 * 查询所有任务名称列表
	 */
	QUERY_ALL_IRTASK(0xa0),
	/**
	 * 添加任务
	 */
	ADD_IRTASK(0xa1),
	/**
	 * 删除任务
	 */
	DELETE_IRTASK(0xa2),
	/**
	 * 修改任务
	 */
	UPDATE_IRTASK(0xa3),
	/**
	 * 查询指定任务详细
	 */
	QUERY_TASKINFO_TASKID(0xa4),
	/**
	 * 查询所有定时任务详细
	 */
	QUERY_ALL_TASKINFO(0xa5),
	/**
	 * 根据设备查询任务详细
	 */
	QUERY_TASKINFO_DEVICE(0xa6),
	/**
	 * 更新任务状态
	 */
	UPDATE_IRTASK_STATE(0xa7),
	
	SET_SMART_MODE(0xb0),
	
	SET_SMART_MODE_LOW_TEMPERATURE_CMD(0xb1),
	
	SET_SMART_MODE_HIGH_TEMPERATURE_CMD(0xb2),
	
	QUERY_THE_SMART_MODE(0xb3),
	
	UPDATE_SMART_STATE(0xb4),
	
	REQUEST_REMOTECONTROL_VERSION(0xe0),
	
	REQUEST_TO_UPGRADE(0xe1),
	
	SEND_UPGRADE_DATA(0xe2),
	
	CUSTOM_REMOTE_CONTROL_KEYS(0x97),
	
	REQUEST_CUSTOM_REMOTE_CONTROL_BY_DEVICEADDR_AND_PROFILEID(0x98),
	
	SEND_CUSTOM_REMOTE_CONTROL_KEY(0x99),
	
	REQUEST_REMOTE_CONTROL_FIRMWARE_LENGTH(0X62),
	
	UPGRADE_OK(0X63),
	
	GET_ONLINESTATUS_OF_CLIENT(0x64),
	;
	
	private int v;
	
	private IrControlTypeEnum(int v) {

        this.v = v;
    }

    public int getVal() {
        return v;
    }

    public static IrControlTypeEnum valuesOf(int e) {
    	IrControlTypeEnum[] vs = IrControlTypeEnum.values();
        if (vs == null || vs.length == 0) {
            return null;
        }
        for (IrControlTypeEnum event : vs) {
            if (event.getVal() == e) {
                return event;
            }
        }
        return null;
    }
}
