package com.b_noble.n_life.event;

/**
 * 公司：深圳市中泰智丰物联网科技有限公司
 * 项目：智能家居
 * 简述：响应类型枚举类
 * 作者：zhangfan
 * 时间：2016-08-02
 * 版本：V0.0.1
 */
public enum ResponseTypeEnum {

	/**
	 * 获取当前所有设备响应
	 */
	RESPONSE_GET_DEVICE(0x86),
	
	/**
	 * 上报新设备
	 */
	RESPONSE_REPORT_NEW_DEVICE(0X87),
	
	/**
	 * 设置设备开关状态响应类型
	 */
	RESPONSE_SET_DEVICE_STATE(0x8E),
	
	/**
	 * 删除指定设备响应类型
	 */
	RESPONSE_DELETE_DEVICE(0x8C),
	
	/**
	 * 更新设备名称响应类型
	 */
	RESPONSE_UPDATE_DEVICENAME(0x8D),
	
	/**
	 * 获取设备的开关状态响应类型
	 */
	RESPONSE_GET_DEVICE_STATE(0x8F),
	
	/**
	 * 心跳响应类型
	 */
	RESPONSE_SEND_HEARTBEAT(0x88),
	
	/**
	 * 获取设备亮度相应类型
	 */
	RESPONSE_GET_DEVICE_LEVEL(0x91),
	
	/**
	 * 设置设备亮度响应类型
	 */
	RESPONSE_SET_DEVICE_LEVEL(0x90),
	
	/**
	 * 获取设备色调与饱和度响应类型
	 */
	RESPONSE_GET_DEVICE_HUE(0x93),
	
	/**
	 * 设置设备色调响应类型
	 */
	RESPONSE_SET_DEVICE_HUE(0x92),
	
	/**
	 * 获取设备色温响应类型
	 */
	RESPONSE_GET_DEVICE_COLORTEMPERATURE(0x95),
	
	/**
	 * 设置设备色温响应类型
	 */
	RESPONSE_SET_COLOR_TEMPERATURE(0x94),
	
	
	/**
	 * 获取组响应类型
	 */
	RESPONSE_GET_GROUP(0x0C),
	
	/**
	 * 添加指定设备到组响应类型
	 */
	REPOSNE_ADD_DEVICE_GROUP(0x0B),
	
	/**
	 * 从组中删除指定设备相应类型
	 */
	REPONSE_DELETE_DEVICE_GROUP(0x0F),
	
	/**
	 * 获取组成员名单响应类型
	 */
	REPONSE_GET_GROUP_MEMBER(0X10),
	
	/**
	 * 获取场景响应类型
	 */
	RESPONSE_GET_SENCE(0xAC),
	
	/**
	 * 添加场景响应类型
	 */
	RESPONSE_ADD_SENCE(0xAA),
	
	/**
	 * 添加设备到场景
	 */
	REPOSNE_ADD_DEVICE_SENCE(0x4B),
	
	/**
	 * 获取场景成员详细信息响应类型
	 */
	RESPONSE_GET_SENCE_DETAILED(0xAD),
	
	/**
	 * 删除场景中的指定成员响应类型
	 */
	RESPONSE_DELETE_SENCE_MEMBER(0x4C),
	
	/**
	 * 更新场景名称响应类型
	 */
	RESPONSE_UPDATE_SCENENAME(0xAE),
	
	/**
	 * 调用场景返回
	 */
	RESPONSE_RECALL_SCENE(0XB0),
	
	/**
	 * 删除场景返回
	 */
	RESPONSE_DELETE_SCENE(0XAF),
	
	/**
	 * 获取定时任务响应类型
	 */
	RESPONSE_GET_TIMERTASK(0x11),
	
	/**
	 * 获取所有任务
	 */
	//REPOSNE_GET_ALL_TASK(0xB8),
	
	/**
	 * 添加任务响应类型
	 */
	RESPONSE_ADD_TASK(0xB5),
	
	/**
	 * 获取任务详细
	 */
	REPOSNE_GET_TASKINFO(0xBC),
	
	/**
	 * 获取指定场景任务
	 */
	RESPONSE_TASK_SCENE(0xff),
	
	/**
	 * 获取指定设备任务
	 */
	RESPONSE_GET_TASK_DEVICE(0xff),
	
	/**
	 * 查询联动任务详细
	 */
	RESPONSE_GET_LINKAGE_TASK_DETAILS(0XC1),
	
	/**
	 * 删除联动任务
	 */
	RESPONSE_DELETE_LINKAGE_TASK(0XC2),
	/**
	 * 查询指定场景的联动任务
	 */
	//RESPONSE_GET_LINKAGE_SCENE(0XC3),
	/**
	 * 查询指定设备的联动任务
	 */
	//RESPONSE_GET_LINKAGE_DEVICE(0XC4),
	
	/**
	 * 添加区域
	 */
	RESPONSE_ADD_AREA(0XC5),
	
	/**
	 * 查询区域详细返回
	 */
	RESPONSE_GET_AREA_DETAILS(0XC6),
	
	/**
	 * 获取所有设备
	 */
	RESPONSE_GET_ALL_AREA(0XC8),
	
	/**
	 * 获取指定设备的联动任务
	 */
	RESPONSE_TASK_UID(0x5E),
	
	/**
	 * 删除定时任务响应类型
	 */
	RESPONSE_DELETE_TIMERTASK(0x13),
	
	/**
	 * 更新任务响应类型
	 */
	RESPONSE_UPDATE_TASK(0x5B),
	
	/**
	 * 获取网关信息响应类型
	 */
	RESPONSE_GET_GATE_INFO(0x20),
	
	/**
	 * 获取 RSSI响应类型
	 */
	RESPONSE_GET_RSSI(0x16),
	
	/**
	 * 获取所有任务响应类型
	 */
	RESPONSE_GET_ALL_TASK(0x25),
	
	/**
	 * 删除任务响应类型
	 */
//	RESPONSE_DELETE_TASK(0xBA),
	
	/**
	 * 查看指定任务详情响应类型
	 */
	RESPONSE_GET_TASKDETAILED(0x24),
	
	/**
	 * 获取指定设备的色温响应类型
	 */
	RESPONSE_GET_TEMPERATURE(0x27),
	
	/**
	 * 对网关中一字符串信息操作响应类型
	 */
	RESPONSE_GATEWAY_STRING(0x28),
	
	/**
	 * 组改名响应类型
	 */
	RESPONSE_UPDATE_GROUPNAME(0xAF),
	
	/**
	 * 节点主动上报响应类型
	 */
	REPSONSE_NODE_REPORT(0xA1),
	
	/**
	 * 添加指定设备定时任务
	 */
	RESPONSE_ADD_TIMING_TASK(0x61),
	/**
	 * 删除指定设备定时任务
	 */
	RESPONSE_DELETE_TIMING_TASK(0x62),
	/**
	 * 更新设备定时任务
	 */
	RESPONSE_UPDATE_TIMING_TASK(0x63),
	
	/**
	 * 获取设备定时任务
	 */
	RESPONSE_GET_TIMING_TASK(0x64),
	
	/**
	 * 验证管理密码
	 */
	RESPONSE_VERIFICATION_MANAGERPWD(0XCB),
	
	/**
	 * 获取密码
	 */
	RESPONSE_QUERY_PWD(0XCC),
	/**
	 * 修改密码
	 */
	RESPONSE_MODIFY_PWD(0XCD),
	/**
	 * 修改管理密码
	 */
	RESPONSE_MODIFY_MANAGER_PWD(0XCE),
	/**
	 * 局域网登录网关
	 */
	RESPONSE_LOGIN_LAN(0XCA),
	
	/**
	 * 绑定网关
	 */
	REPONSE_BIND_GA(0xd2),
	/**
	 * 添加用户
	 */
	REPONSE_ADD_USER_GA(0XD3),
	/**
	 * 设备上报
	 */
	RESPONSE_ENDPOINT_REPORT(0XA1),
	
	/**
	 * 退出登录指令
	 */
	RESPONSE_SIGNOUT(0x6e),
	/**
	 * 未找到网关
	 */
	NOT_FIND_GA(0x6f),
	/**
	 * 未找到ir
	 */
	NOT_FIND_IR(0x5f),
	
	/**
	 * 设置窗帘电机方向
	 */
	RESPONSE_SET_ELECTRIC_MOTOR_DIRECTION(0X96),
	
	/**
	 * 配置窗帘电机
	 */
	RESPONSE_CONFIGURATION_ELECTRIC_MOTOR(0X97),
	
	/**
	 * 查询窗帘电机配置信息
	 */
	RESPONSE_QUERY_ELECTRIC_INFO(0X98),
	
	/**
	 * 查询窗帘电机状态
	 */
	RESPONSE_QUERY_MOTOR_STATUS(0X99),
	/**
	 * 打开或关闭窗帘
	 */
	RESPONSE_OPEN_OR_CLOSE_CURTAIN(0X9A),
	
	/**
	 * 停止操作窗帘
	 */
	RESPONSE_STOP_OPERATING_CURTAIN(0X9B),
	/**
	 * 打开或关闭窗帘
	 */
	RESPONSE_QUERY_CURTAIN_POSITION(0X9C),
	
	/**
	 * 设置门锁开关状态
	 */
	RESPONSE_SET_DOORLOCK_SWITCH_STATE(0x70),
	
	/**
	 * 查询门锁开关状态
	 */
	RESPONSE_QUERY_DOORLOCK_SWITCH_STATE(0x71),
	
	/**
	 * 操作门锁通知
	 */
	RESPONSE_OPERATION_EVENT_NOTIFICATION(0X73),
	
	/**
	 * 设置门锁权限
	 *//*
	RESPONSE_SET_PERMISSION_DOORLOCK(0x73),
	
	*//**
	 * 查询门锁权限
	 *//*
	RESPONSE_QUERY_PERMISSION_DOORLOCK(0x74),*/
	
	/**
	 * 添加用户到门锁
	 */
	RESPONSE_ADD_USER_TO_DOORLOCK(0X75),
	
	/**
	 * 删除用户到门锁
	 */
	RESPONSE_DELETE_USER_TO_DOORLOCK(0X76),
	
	RESPONSE_REQUEST_GATE_ZIGBEE_VERSION(0X7F),
	
	RESPONSE_RESET_GATE(0x83),
	
	RESPONSE_REPORT_UPGRADE_STATUS(0x7e),
	;
	
	private int v;

	private ResponseTypeEnum(int v) {

        this.v = v;
    }

	public int getVal() {
		return v;
	}

	public static ResponseTypeEnum valuesOf(int e) {
		ResponseTypeEnum[] vs = ResponseTypeEnum.values();
		if (vs == null || vs.length == 0) {
			return null;
		}
		for (ResponseTypeEnum event : vs) {
			if (event.getVal() == e) {
				return event;
			}
		}
		return null;
	}
}
