package com.b_noble.n_life.handler.processing;

import com.b_noble.n_life.event.ControlTypeEnum;
import com.b_noble.n_life.model.RequesUpdateTaskStateData;
import com.b_noble.n_life.model.Request3DModuleData;
import com.b_noble.n_life.model.RequestAddSenceData;
import com.b_noble.n_life.model.RequestAddTaskData;
import com.b_noble.n_life.model.RequestAddUserToGaDate;
import com.b_noble.n_life.model.RequestAlarmRecordsData;
import com.b_noble.n_life.model.RequestAreaData;
import com.b_noble.n_life.model.RequestBindDeviceData;
import com.b_noble.n_life.model.RequestConfigurWIFIInfoData;
import com.b_noble.n_life.model.RequestConfigurationElectricMotorData;
import com.b_noble.n_life.model.RequestDeleteDeviceData;
import com.b_noble.n_life.model.RequestDeleteSceneData;
import com.b_noble.n_life.model.RequestDeleteTaskData;
import com.b_noble.n_life.model.RequestDeleteUserFromGatewayData;
import com.b_noble.n_life.model.RequestDoorlockData;
import com.b_noble.n_life.model.RequestDoorlockUserData;
import com.b_noble.n_life.model.RequestGetColorTemperatureData;
import com.b_noble.n_life.model.RequestGetDeviceHueAndSatData;
import com.b_noble.n_life.model.RequestGetDeviceLevelData;
import com.b_noble.n_life.model.RequestGetDeviceStateData;
import com.b_noble.n_life.model.RequestGetSceneMemberData;
import com.b_noble.n_life.model.RequestGetSensorTaskByUidData;
import com.b_noble.n_life.model.RequestGetTaskBySceneIdData;
import com.b_noble.n_life.model.RequestGetTaskByUidData;
import com.b_noble.n_life.model.RequestGetTaskInfoData;
import com.b_noble.n_life.model.RequestGyDoorlockData;
import com.b_noble.n_life.model.RequestHead;
import com.b_noble.n_life.model.RequestK1DeviceData;
import com.b_noble.n_life.model.RequestLinkageData;
import com.b_noble.n_life.model.RequestLoginGaByLanData;
import com.b_noble.n_life.model.RequestLoginValidateData;
import com.b_noble.n_life.model.RequestMessage;
import com.b_noble.n_life.model.RequestModifyPwdData;
import com.b_noble.n_life.model.RequestOpenOrCloseCurtainData;
import com.b_noble.n_life.model.RequestQueryCurtainPositionData;
import com.b_noble.n_life.model.RequestQueryElectricInfoData;
import com.b_noble.n_life.model.RequestQueryElectricMotorStatusData;
import com.b_noble.n_life.model.RequestQueryPwdData;
import com.b_noble.n_life.model.RequestRecallSceneData;
import com.b_noble.n_life.model.RequestRollingBlindData;
import com.b_noble.n_life.model.RequestSetColorTemperatureData;
import com.b_noble.n_life.model.RequestSetDeviceColorData;
import com.b_noble.n_life.model.RequestSetDeviceLevelData;
import com.b_noble.n_life.model.RequestSetDeviceStateData;
import com.b_noble.n_life.model.RequestSetDlectricMotorDirectionData;
import com.b_noble.n_life.model.RequestSetDoorlockSwitchStateData;
import com.b_noble.n_life.model.RequestStopOperatingCurtainData;
import com.b_noble.n_life.model.RequestThermostatData;
import com.b_noble.n_life.model.RequestTimerTaskData;
import com.b_noble.n_life.model.RequestUpdateDeviceData;
import com.b_noble.n_life.model.RequestUpdateSceneNameData;
import com.b_noble.n_life.model.RequestUpdateTaskData;
import com.b_noble.n_life.model.RequestUpdateTimerTaskData;
import com.b_noble.n_life.model.RequestUpgradeDate;
import com.b_noble.n_life.model.RequestUserToGaDate;
import com.b_noble.n_life.model.RequestVerificationManagerPwdData;
import com.b_noble.n_life.model.ScenePanelData;

import io.netty.buffer.ByteBuf;

/**
 * 公司：深圳市中泰智丰物联网科技有限公司 项目：智能家居 简述：编码处理类 作者：zhangfan 时间：2016-08-02 版本：V0.0.1
 */
public class GaEncoderProcessing {

	public static void processing(RequestMessage requestMessage, ByteBuf buf) {

		RequestHead head = requestMessage.getHeader();

		/**
		 * 允许设备入网
		 */
		if (head.getControlType() == ControlTypeEnum.ALLOW_NET.getVal()) {
			// state
			buf.writeByte(0xFF);

			// tbd 8 bytes
			for (int i = 0; i < 10; i++) {
				buf.writeByte(0x00);
			}

		}

		/**
		 * 上报新设备返回
		 */
		if (head.getControlType() == ControlTypeEnum.REPORT_NEW_DEVICE.getVal()) {
			// state
			buf.writeByte(0xFF);

			// tbd 8 bytes
			for (int i = 0; i < 10; i++) {
				buf.writeByte(0x00);
			}

		}

		/**
		 * 设定指定设备开关状态
		 */
		if (head.getControlType() == ControlTypeEnum.SET_DEVICE_STATE.getVal()) {

			RequestSetDeviceStateData data = (RequestSetDeviceStateData) requestMessage.getData();
			GaEncoderProcessingRealization.setDeviceState(data, buf);
		}
		/**
		 * 获取设备开关状态
		 */
		if (head.getControlType() == ControlTypeEnum.GET_DEVICE_STATE.getVal()) {

			RequestGetDeviceStateData data = (RequestGetDeviceStateData) requestMessage.getData();
			GaEncoderProcessingRealization.getDeviceState(data, buf);
		}

		/**
		 * 添加场景
		 */
		if (head.getControlType() == ControlTypeEnum.ADD_SENCE.getVal()) {

			RequestAddSenceData data = (RequestAddSenceData) requestMessage.getData();
			GaEncoderProcessingRealization.addSence(data, buf);
		}
		/**
		 * 修改场景
		 */
		if (head.getControlType() == ControlTypeEnum.MODITY_SCENE.getVal()) {

			RequestAddSenceData data = (RequestAddSenceData) requestMessage.getData();
			GaEncoderProcessingRealization.modifyScene(data, buf);
		}

		/**
		 * 调用场景
		 */
		if (head.getControlType() == ControlTypeEnum.RECALL_SENCE.getVal()) {

			RequestRecallSceneData data = (RequestRecallSceneData) requestMessage.getData();
			GaEncoderProcessingRealization.recallSence(data, buf);
		}

		/**
		 * 删除场景
		 */
		if (head.getControlType() == ControlTypeEnum.DELETE_SENCE.getVal()) {

			RequestDeleteSceneData data = (RequestDeleteSceneData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteSence(data, buf);
		}

		/************************************** task *********************************/
		/**
		 * 查询所有任务
		 */
		/*
		 * if (head.getControlType() == ControlTypeEnum.GET_ALL_TASK.getVal()) {
		 * 
		 * buf.writeByte(0xff);
		 * 
		 * // tbd 8 bytes for (int i = 0; i < 10; i++) { buf.writeByte(0x00); }
		 * 
		 * }
		 */

		/**
		 * 增加定时任务
		 */
		if (head.getControlType() == ControlTypeEnum.ADD_TASK.getVal()) {

			/**
			 * 添加场景定时任务
			 */
			if (((RequestTimerTaskData) requestMessage.getData()).getTaskType() == 0x02) {

				System.out.println("EncoderProcessing类输出： 执行添加场景定时任务操作");
				RequestTimerTaskData data = (RequestTimerTaskData) requestMessage.getData();
				GaEncoderProcessingRealization.addSceneTimerTask(data, buf);
			}
			/**
			 * 添加设备定时任务
			 */
			else if (((RequestTimerTaskData) requestMessage.getData()).getTaskType() == 0x01) {
				System.out.println("EncoderProcessing类输出： 执行添加设备定时任务操作");
				RequestTimerTaskData data = (RequestTimerTaskData) requestMessage.getData();
				GaEncoderProcessingRealization.addDeviceTimerTask(data, buf);
			}
		}

		/**
		 * 增加联动任务
		 */
		if (head.getControlType() == ControlTypeEnum.ADD_LINKAGE_TASK.getVal()) {
			/**
			 * 添加场景联动任务
			 */
			if (((RequestLinkageData) requestMessage.getData()).getLinkageType() == 0x02) {

				RequestLinkageData data = (RequestLinkageData) requestMessage.getData();
				GaEncoderProcessingRealization.addSceneLinkageTask(data, buf);
			}
			/**
			 * 添加设备联动任务
			 */
			else if (((RequestLinkageData) requestMessage.getData()).getLinkageType() == 0x01) {

				RequestLinkageData data = (RequestLinkageData) requestMessage.getData();
				GaEncoderProcessingRealization.addDeviceLinkageTask(data, buf);
			}
		}

		/**
		 * 修改联动任务
		 */
		if (head.getControlType() == ControlTypeEnum.MODITY_LINKAGE_TASK.getVal()) {
			/**
			 * 修改场景联动任务
			 */
			if (((RequestLinkageData) requestMessage.getData()).getLinkageType() == 0x02) {

				RequestLinkageData data = (RequestLinkageData) requestMessage.getData();
				GaEncoderProcessingRealization.moditySceneLinkageTask(data, buf);
			}
			/**
			 * 修改设备联动任务
			 */
			else if (((RequestLinkageData) requestMessage.getData()).getLinkageType() == 0x01) {

				RequestLinkageData data = (RequestLinkageData) requestMessage.getData();
				GaEncoderProcessingRealization.modityDeviceLinkageTask(data, buf);
			}
		}

		/**
		 * 更新任务
		 */
		if (head.getControlType() == ControlTypeEnum.UPDATE_TASK.getVal()) {

			/**
			 * update传感器任务
			 */
			if (requestMessage.getData() instanceof RequestAddTaskData) {
				System.out.println("EncoderProcessing类输出： 执行更新传感器任务操作");
				RequestUpdateTaskData data = (RequestUpdateTaskData) requestMessage.getData();
				GaEncoderProcessingRealization.updateSensorTask(data, buf);
			}
			/**
			 * 添加定时任务
			 */
			else if (requestMessage.getData() instanceof RequestUpdateTimerTaskData) {

				System.out.println("EncoderProcessing类输出： 执行更新定时任务操作");
				RequestUpdateTimerTaskData data = (RequestUpdateTimerTaskData) requestMessage.getData();
				GaEncoderProcessingRealization.updateTimerTask(data, buf);
			}
		}

		/**
		 * 设定指定设备的亮度
		 */
		if (head.getControlType() == ControlTypeEnum.SET_DEVICE_LEVEL.getVal()) {

			RequestSetDeviceLevelData data = (RequestSetDeviceLevelData) requestMessage.getData();

			GaEncoderProcessingRealization.setDeviceLevel(data, buf);
		}

		/**//**
			 * 获取指定设备的亮度
			 */
		if (head.getControlType() == ControlTypeEnum.GET_DEVICE_LEVEL.getVal()) {

			RequestGetDeviceLevelData data = (RequestGetDeviceLevelData) requestMessage.getData();

			GaEncoderProcessingRealization.getDeviceLevel(data, buf);
		}

		/**
		 * 设置灯光颜色
		 */
		if (head.getControlType() == ControlTypeEnum.SET_DEVICE_COLOR.getVal()) {

			RequestSetDeviceColorData data = (RequestSetDeviceColorData) requestMessage.getData();

			GaEncoderProcessingRealization.setDeviceColor(data, buf);
		}

		/**
		 * 设置灯色温
		 */
		if (head.getControlType() == ControlTypeEnum.SET_COLOR_TEMPERATURE.getVal()) {

			RequestSetColorTemperatureData data = (RequestSetColorTemperatureData) requestMessage.getData();

			GaEncoderProcessingRealization.setColorTemperature(data, buf);
		}

		/**
		 * 删除指定任务
		 */
		if (head.getControlType() == ControlTypeEnum.DELETE_TASK.getVal()) {

			RequestDeleteTaskData data = (RequestDeleteTaskData) requestMessage.getData();

			GaEncoderProcessingRealization.deleteTask(data, buf);
		}

		/**
		 * 删除指定设备
		 */
		if (head.getControlType() == ControlTypeEnum.DELETE_DEVICE.getVal()) {

			RequestDeleteDeviceData data = (RequestDeleteDeviceData) requestMessage.getData();

			GaEncoderProcessingRealization.deleteDevice(data, buf);
		}

		/**
		 * 更新设备名称
		 */
		if (head.getControlType() == ControlTypeEnum.UPDATE_DEVICE_NAME.getVal()) {

			RequestUpdateDeviceData data = (RequestUpdateDeviceData) requestMessage.getData();

			GaEncoderProcessingRealization.updateDeviceName(data, buf);
		}
		/**
		 * 获取设备色调与饱和度
		 */
		if (head.getControlType() == ControlTypeEnum.GET_DEVICE_HUE.getVal()) {

			RequestGetDeviceHueAndSatData data = (RequestGetDeviceHueAndSatData) requestMessage.getData();

			GaEncoderProcessingRealization.getDeviceHueAndSat(data, buf);
		}

		/**
		 * 获取设备色温
		 */
		if (head.getControlType() == ControlTypeEnum.GET_DEVICE_COLORTEMPERATURE.getVal()) {

			RequestGetColorTemperatureData data = (RequestGetColorTemperatureData) requestMessage.getData();

			GaEncoderProcessingRealization.getColorTemperature(data, buf);
		}

		/**
		 * 更新场景名称
		 * 
		 */
		if (head.getControlType() == ControlTypeEnum.UPDATE_SENCE_NAME.getVal()) {

			RequestUpdateSceneNameData data = (RequestUpdateSceneNameData) requestMessage.getData();

			GaEncoderProcessingRealization.updateSceneName(data, buf);
		}

		/**
		 * 获取场景中成员
		 */
		if (head.getControlType() == ControlTypeEnum.GET_SENCE_MEMBER.getVal()) {

			RequestGetSceneMemberData data = (RequestGetSceneMemberData) requestMessage.getData();

			GaEncoderProcessingRealization.getSceneMember(data, buf);
		}

		/**
		 * 删除指定场景的成员
		 */
		/*
		 * if (head.getControlType() ==
		 * ControlTypeEnum.DELETE_SENCE_MEMBER.getVal()) {
		 * RequestDeleteSceneMemberData data = (RequestDeleteSceneMemberData)
		 * requestMessage.getData();
		 * 
		 * GaEncoderProcessingRealization.delteteSceneMember(data, buf); }
		 */

		/**
		 * 将指定设备添加到场景中 升级后去除掉
		 */
		/*
		 * if (head.getControlType() ==
		 * ControlTypeEnum.ADD_DEVICE_SENCE.getVal()) {
		 * RequestAddDeviceToSenceData data = (RequestAddDeviceToSenceData)
		 * requestMessage.getData();
		 * 
		 * GaEncoderProcessingRealization.addDeviceToScene(data, buf); }
		 */

		/**
		 * 获取定时任务详细
		 */
		if (head.getControlType() == ControlTypeEnum.GET_TASK_INFO.getVal()) {
			RequestGetTaskInfoData data = (RequestGetTaskInfoData) requestMessage.getData();
			GaEncoderProcessingRealization.getTaskInfo(data, buf);
		}
		/**
		 * 更改定时任务状态
		 */
		if (head.getControlType() == ControlTypeEnum.UPDATE_TASK_STATE.getVal()) {
			RequesUpdateTaskStateData data = (RequesUpdateTaskStateData) requestMessage.getData();
			GaEncoderProcessingRealization.updateTaskState(data, buf);
		}

		/**
		 * 获取联动任务详细
		 */
		if (head.getControlType() == ControlTypeEnum.GET_LINKAGE_TASK_DETAILS.getVal()) {
			RequestLinkageData data = (RequestLinkageData) requestMessage.getData();
			GaEncoderProcessingRealization.getLinkageTaskInfo(data, buf);
		}
		/**
		 * 获取指定场景联动任务列表
		 */
		if (head.getControlType() == ControlTypeEnum.GET_LINKAGE_SCENE.getVal()) {
			RequestGetTaskBySceneIdData data = (RequestGetTaskBySceneIdData) requestMessage.getData();
			GaEncoderProcessingRealization.getLinkageScene(data, buf);
		}
		/**
		 * 获取指定设备联动任务列表
		 */
		if (head.getControlType() == ControlTypeEnum.GET_LINKAGE_DEVICE.getVal()) {
			RequestGetTaskByUidData data = (RequestGetTaskByUidData) requestMessage.getData();
			GaEncoderProcessingRealization.getLinkageDevice(data, buf);
		}

		/**
		 * 获取指定场景的任务
		 */
		if (head.getControlType() == ControlTypeEnum.GET_TASK_SCENE.getVal()) {

			RequestGetTaskBySceneIdData data = (RequestGetTaskBySceneIdData) requestMessage.getData();
			GaEncoderProcessingRealization.getTimerTaskBySceneId(data, buf);
		}

		/**
		 * 获取指定设备的任务
		 */
		if (head.getControlType() == ControlTypeEnum.GET_TASK_DEVICE.getVal()) {

			RequestGetTaskByUidData data = (RequestGetTaskByUidData) requestMessage.getData();
			GaEncoderProcessingRealization.getTaskByUId(data, buf);
		}

		/**
		 * 获取指定设备联动任务
		 */
		if (head.getControlType() == ControlTypeEnum.GET_TASK_UID.getVal()) {

			RequestGetSensorTaskByUidData data = (RequestGetSensorTaskByUidData) requestMessage.getData();
			GaEncoderProcessingRealization.getSensorTaskByUid(data, buf);
		}

		/**
		 * 删除联动任务
		 */
		if (head.getControlType() == ControlTypeEnum.DELETE_LINKAGE_TASK.getVal()) {
			RequestDeleteTaskData data = (RequestDeleteTaskData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteLinkageTask(data, buf);
		}

		/**
		 * 登录验证
		 */
		if (head.getControlType() == ControlTypeEnum.LOGIN_VALODATE.getVal()) {
			RequestLoginValidateData data = (RequestLoginValidateData) requestMessage.getData();
			GaEncoderProcessingRealization.loginValidate(data, buf);
		}

		/**
		 * 获取场景列表
		 */
		if (head.getControlType() == ControlTypeEnum.GET_SENCE.getVal()) {
			// state
			buf.writeByte(0xFF);

			// tbd 8 bytes
			for (int i = 0; i < 10; i++) {
				buf.writeByte(0x00);
			}

		}
		/**
		 * 获取设备列表
		 */
		if (head.getControlType() == ControlTypeEnum.GET_DEVICE.getVal()) {
			// state
			buf.writeByte(0xff);

			// tbd 8 bytes
			for (int i = 0; i < 10; i++) {
				buf.writeByte(0x00);
			}

		}
		/**
		 * 发送心跳包
		 */
		if (head.getControlType() == ControlTypeEnum.SEND_HEARTBEAT.getVal()) {
			// state
			buf.writeByte(0x00);

			// tbd 8 bytes
			for (int i = 0; i < 10; i++) {
				buf.writeByte(0x00);
			}

		}

		/**
		 * 验证管理密码
		 */
		if (head.getControlType() == ControlTypeEnum.VERIFICATION_MANAGERPWD.getVal()) {
			RequestVerificationManagerPwdData data = (RequestVerificationManagerPwdData) requestMessage.getData();
			GaEncoderProcessingRealization.verificationManagerPwd(data, buf);
		}

		/**
		 * 查询密码
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_PASSWORD.getVal()) {

			RequestQueryPwdData data = (RequestQueryPwdData) requestMessage.getData();
			GaEncoderProcessingRealization.queryPwd(data, buf);
		}

		/**
		 * 修改登录密码
		 */
		if (head.getControlType() == ControlTypeEnum.MODIFY_LOGIN_PASSWORD.getVal()) {

			RequestModifyPwdData data = (RequestModifyPwdData) requestMessage.getData();
			GaEncoderProcessingRealization.modifyPwd(data, buf);
		}

		/**
		 * 修改管理密码
		 */
		if (head.getControlType() == ControlTypeEnum.MODIFY_MANAGE_PASSWORD.getVal()) {

			RequestModifyPwdData data = (RequestModifyPwdData) requestMessage.getData();
			GaEncoderProcessingRealization.modifyPwd(data, buf);
		}

		/**
		 * 局域网登录网关
		 */
		if (head.getControlType() == ControlTypeEnum.LOGIN_GA_LAN.getVal()) {
			RequestLoginGaByLanData data = (RequestLoginGaByLanData) requestMessage.getData();
			GaEncoderProcessingRealization.loginGaByLan(data, buf);
		}
		/**
		 * 绑定网关
		 */
		if (head.getControlType() == ControlTypeEnum.BING_GA.getVal()) {
			RequestUserToGaDate data = (RequestUserToGaDate) requestMessage.getData();
			GaEncoderProcessingRealization.bindGa(data, buf);
		}
		/**
		 * 添加用户
		 */
		if (head.getControlType() == ControlTypeEnum.ADD_USER_GA.getVal()) {
			RequestAddUserToGaDate data = (RequestAddUserToGaDate) requestMessage.getData();
			GaEncoderProcessingRealization.addUserToGa(data, buf);
		}

		/**
		 * 新增区域
		 */
		if (head.getControlType() == ControlTypeEnum.ADD_AREA.getVal()) {
			RequestAreaData data = (RequestAreaData) requestMessage.getData();

			GaEncoderProcessingRealization.addArea(data, buf);
		}

		/**
		 * 查询区域详细
		 */
		if (head.getControlType() == ControlTypeEnum.GET_AREA_DETAILS.getVal()) {
			RequestAreaData data = (RequestAreaData) requestMessage.getData();
			GaEncoderProcessingRealization.getAreaDetails(data, buf);
		}

		/**
		 * 删除区域
		 */
		if (head.getControlType() == ControlTypeEnum.DELETE_AREA.getVal()) {
			RequestAreaData data = (RequestAreaData) requestMessage.getData();

			GaEncoderProcessingRealization.deleteArea(data, buf);
		}
		/**
		 * 获取所有区域
		 */
		if (head.getControlType() == ControlTypeEnum.GET_ALL_AREA.getVal()) {

			RequestAreaData data = (RequestAreaData) requestMessage.getData();
			GaEncoderProcessingRealization.getAllArea(data, buf);
		}

		/**
		 * 设置窗帘电机方向
		 */
		if (head.getControlType() == ControlTypeEnum.SET_ELECTRIC_MOTOR_DIRECTION.getVal()) {
			RequestSetDlectricMotorDirectionData data = (RequestSetDlectricMotorDirectionData) requestMessage.getData();
			GaEncoderProcessingRealization.setDlectricMotorDirection(data, buf);
		}

		/**
		 * 配置窗帘电机
		 */
		if (head.getControlType() == ControlTypeEnum.CONFIGURATION_ELECTRIC_MOTOR.getVal()) {
			RequestConfigurationElectricMotorData data = (RequestConfigurationElectricMotorData) requestMessage
					.getData();
			GaEncoderProcessingRealization.configurationElectricMotor(data, buf);
		}

		/**
		 * 查询窗帘电机配置信息
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_ELECTRIC_INFO.getVal()) {
			RequestQueryElectricInfoData data = (RequestQueryElectricInfoData) requestMessage.getData();
			GaEncoderProcessingRealization.queryElectricInfo(data, buf);
		}

		/**
		 * 查询窗帘电机状态
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_MOTOR_STATUS.getVal()) {
			RequestQueryElectricMotorStatusData data = (RequestQueryElectricMotorStatusData) requestMessage.getData();
			GaEncoderProcessingRealization.queryElectricMotorStatus(data, buf);
		}

		/**
		 * 打开或关闭窗帘
		 */
		if (head.getControlType() == ControlTypeEnum.OPEN_OR_CLOSE_CURTAIN.getVal()) {
			RequestOpenOrCloseCurtainData data = (RequestOpenOrCloseCurtainData) requestMessage.getData();
			GaEncoderProcessingRealization.openOrCloseCurtain(data, buf);
		}

		/**
		 * 停止操作窗帘
		 */
		if (head.getControlType() == ControlTypeEnum.STOP_OPERATING_CURTAIN.getVal()) {
			RequestStopOperatingCurtainData data = (RequestStopOperatingCurtainData) requestMessage.getData();
			GaEncoderProcessingRealization.stopOperatingCurtain(data, buf);
		}

		/**
		 * 查询窗帘位置
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_CURTAIN_POSITION.getVal()) {
			RequestQueryCurtainPositionData data = (RequestQueryCurtainPositionData) requestMessage.getData();
			GaEncoderProcessingRealization.queryCurtainPosition(data, buf);
		}

		/**
		 * 设置门锁开关状态
		 */
		if (head.getControlType() == ControlTypeEnum.SET_DOORLOCK_SWITCH_STATE.getVal()) {
			RequestSetDoorlockSwitchStateData data = (RequestSetDoorlockSwitchStateData) requestMessage.getData();
			GaEncoderProcessingRealization.setDoorlockSwitchState(data, buf);
		}

		/**
		 * 查询门锁开关状态
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_DOORLOCK_SWITCH_STATE.getVal()) {
			RequestSetDoorlockSwitchStateData data = (RequestSetDoorlockSwitchStateData) requestMessage.getData();
			GaEncoderProcessingRealization.quertDoorlockSwitchState(data, buf);
		}
		/**
		 * 查询门锁电量
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_DOORLOCK_ELECTRICITY.getVal()) {
			RequestSetDoorlockSwitchStateData data = (RequestSetDoorlockSwitchStateData) requestMessage.getData();
			GaEncoderProcessingRealization.queryDoorlockElectricity(data, buf);
		}

		/**
		 * 设置门锁权限
		 */
		/*
		 * if(head.getControlType() ==
		 * ControlTypeEnum.SET_PERMISSION_DOORLOCK.getVal()) {
		 * RequestPermissionDoorlockData data = (RequestPermissionDoorlockData)
		 * requestMessage.getData();
		 * GaEncoderProcessingRealization.setPermissionDoorlock(data,buf); }
		 * 
		 *//**
			 * 查询门锁权限
			 *//*
			 * if(head.getControlType() ==
			 * ControlTypeEnum.QUERY_PERMISSION_DOORLOCK.getVal()) {
			 * RequestPermissionDoorlockData data =
			 * (RequestPermissionDoorlockData) requestMessage.getData();
			 * GaEncoderProcessingRealization.queryPermissionDoorlock(data,buf);
			 * }
			 */
		/**
		 * 设置门锁用户名称
		 */
		if (head.getControlType() == ControlTypeEnum.SET_USER_NAME.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.setUserName(data, buf);
		}
		/**
		 * 获取门锁用户列表
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_USER_INFO.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryDoorUserInfos(data, buf);
		}

		/**
		 * 添加用户到门锁
		 */
		if (head.getControlType() == ControlTypeEnum.ADD_USER_TO_DOORLOCK.getVal()) {
			RequestDoorlockUserData data = (RequestDoorlockUserData) requestMessage.getData();
			GaEncoderProcessingRealization.addUserToDoorlock(data, buf);
		}

		/**
		 * 删除用户到门锁
		 */
		if (head.getControlType() == ControlTypeEnum.DELETE_USER_TO_DOORLOCK.getVal()) {
			RequestDoorlockUserData data = (RequestDoorlockUserData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteUserToDoorlock(data, buf);
		}

		/**
		 * 查询开锁记录
		 */
		if (head.getControlType() == ControlTypeEnum.QUERY_UNLOCK_RECORD.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryUnlockRecord(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_UNLOCK_RECORD_BY_TIME.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryUnlockRecordByTime(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_ABNORMAL_RECORD.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryAbnormalRecord(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_ABNORMAL_RECORD_BY_TIME.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryAbnormalRecordByTime(data, buf);
		}

		/**
		 * 删除开锁记录
		 */
		if (head.getControlType() == ControlTypeEnum.DELETE_UNLOCK_RECORD.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteUnlockRecord(data, buf);
		}

		if (head.getControlType() == ControlTypeEnum.DELETE_ABNORMAL_RECORD.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteAbnormalRecord(data, buf);
		}

		if (head.getControlType() == ControlTypeEnum.SET_THE_LOCK_TIME.getVal()) {
			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.SetTheLocktime(data, buf);
		}

		if (head.getControlType() == ControlTypeEnum.DELETE_USER_FROM_GATEWAY.getVal()) {
			RequestDeleteUserFromGatewayData data = (RequestDeleteUserFromGatewayData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteUserFromGateway(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.REQUEST_GATE_ZIGBEE_VERSION.getVal()) {
			RequestUpgradeDate data = (RequestUpgradeDate) requestMessage.getData();
			GaEncoderProcessingRealization.requestGaOrZigbeeVersion(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.RESET_GATE.getVal()) {
			RequestUpgradeDate data = (RequestUpgradeDate) requestMessage.getData();
			GaEncoderProcessingRealization.upgradeGaOrZigbee(data, buf);
		}

		if (head.getControlType() == ControlTypeEnum.BIND_DEVICE.getVal()) {
			GaEncoderProcessingRealization.requestTemperatureAndHumidity(buf);
		}

		if (head.getControlType() == ControlTypeEnum.CURTAIN_STROKE_CONTROL.getVal()) {

			RequestRollingBlindData data = (RequestRollingBlindData) requestMessage.getData();
			GaEncoderProcessingRealization.curtainStrokeControl(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_STROKE.getVal()) {

			RequestRollingBlindData data = (RequestRollingBlindData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteStroke(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.MODITY_TASK.getVal()) {

			RequestTimerTaskData data = (RequestTimerTaskData) requestMessage.getData();
			if (data.getTaskType() == 1) {
				GaEncoderProcessingRealization.updateDeviceTimerTask(data, buf);
			} else {
				GaEncoderProcessingRealization.updateSceneTimerTask(data, buf);
			}
		}
		if (head.getControlType() == ControlTypeEnum.UPDATE_TASK_NAME.getVal()) {

			RequestTimerTaskData data = (RequestTimerTaskData) requestMessage.getData();
			GaEncoderProcessingRealization.updateTaskName(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.GET_TIMER_TASK.getVal()) {
			RequestTimerTaskData data = (RequestTimerTaskData) requestMessage.getData();

			if (data.getTaskType() == 1) {
				GaEncoderProcessingRealization.getDeviceTimerTask(data, buf);
			} else {
				GaEncoderProcessingRealization.getSceneTimerTask(data, buf);
			}
		}
		if (head.getControlType() == ControlTypeEnum.UPDATE_LINKAGE_NAME.getVal()) {

			RequestLinkageData data = (RequestLinkageData) requestMessage.getData();
			GaEncoderProcessingRealization.updateLinkageName(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.UPDATE_LINKAGE_STATUS.getVal()) {

			RequestLinkageData data = (RequestLinkageData) requestMessage.getData();
			GaEncoderProcessingRealization.updateLinkageStutus(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_ALL_LINKAGE.getVal()) {

			GaEncoderProcessingRealization.queryAllGaLinkage(buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_LINKAGE_UID.getVal()) {

			RequestGetTaskByUidData data = (RequestGetTaskByUidData) requestMessage.getData();
			GaEncoderProcessingRealization.queryGaLinkageByUid(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DEVICE_KEY_CONFIGURE.getVal()) {

			ScenePanelData data = (ScenePanelData) requestMessage.getData();
			GaEncoderProcessingRealization.deviceKeyConfigure(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_CONFIGURE_OF_DEVICEKEY.getVal()) {

			ScenePanelData data = (ScenePanelData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteConfigureOfDeviceKey(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_ALL_CONFIGURE_OF_THE_DEVICE.getVal()) {

			ScenePanelData data = (ScenePanelData) requestMessage.getData();
			GaEncoderProcessingRealization.queryAllConfigureOfTheDevice(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.SET_THE_THERMOSTAT_MODE.getVal()) {

			RequestThermostatData data = (RequestThermostatData) requestMessage.getData();
			GaEncoderProcessingRealization.setTheThermostatMode(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.SET_THE_WIND_SPEED.getVal()) {

			RequestThermostatData data = (RequestThermostatData) requestMessage.getData();
			GaEncoderProcessingRealization.setTheWindSpeed(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.ADJUSTT_THE_TEMPERATURE.getVal()) {

			RequestThermostatData data = (RequestThermostatData) requestMessage.getData();
			GaEncoderProcessingRealization.adjusttTheTemperature(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.SET_THE_RUN_MODE_THAT_POWERRESUME.getVal()) {

			RequestThermostatData data = (RequestThermostatData) requestMessage.getData();
			GaEncoderProcessingRealization.setTheRunModeThatPowerResume(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_THE_THERMOSTAT_CONFIGUREINFO.getVal()) {

			RequestThermostatData data = (RequestThermostatData) requestMessage.getData();
			GaEncoderProcessingRealization.queryTheThermostatConfigureInfo(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_THE_THERMOSTAT_RUN_STATUS.getVal()) {

			RequestThermostatData data = (RequestThermostatData) requestMessage.getData();
			GaEncoderProcessingRealization.queryTheThermostatRunStatus(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.SET_THE_THERMOSTAT_STATE.getVal()) {

			RequestThermostatData data = (RequestThermostatData) requestMessage.getData();
			GaEncoderProcessingRealization.setThermostatState(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.SET_DOORLOCK_SWITCHSTATE.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.setDoorlockSwitchState(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_GYDOORLOCK_SWITCHSTATE.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryGyDoorlockSwitchState(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.CONFIGURE_DOORLOCK_NORMALOPEN.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.configureDoorlockNormalOpen(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_DOORLOCK_RECENT_STATUS.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryDoorlockRecentStatus(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.ADD_GYDOORLOCK_USER.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.addGyDoorlockUser(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_GYDOORLOCK_USER.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteGyDoorlockUser(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.FREEZE_DOORLOCK_USER.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.freezeDoorlockUser(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.MODIFY_DOORLOCK_USER_PASSWD.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.modifyDoorlockUserPasswd(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_ALL_LOCKUSER_INFO.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryAllLockUserInfo(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.MODIFY_DOORLOCK_USER_ALIAS.getVal()) {

			RequestGyDoorlockData data = (RequestGyDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.modifyDoorlockUserAlias(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.FREEZE_LOCK_USER_PASSWORD.getVal()) {

			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.freezeLockUserPassword(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_LOCK_MACHINE_CODE.getVal()) {

			RequestDoorlockData data = (RequestDoorlockData) requestMessage.getData();
			GaEncoderProcessingRealization.queryLockMachineCode(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.BIND_DDEVICE.getVal()) {

			RequestBindDeviceData data = (RequestBindDeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.bindDevice(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.CANCEL_BIND.getVal()) {

			RequestBindDeviceData data = (RequestBindDeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.cancelBind(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_ALL_BIND.getVal()) {

			RequestBindDeviceData data = (RequestBindDeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.queryAllBind(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.QUERY_ALARM_RECORDS.getVal()) {

			RequestAlarmRecordsData data = (RequestAlarmRecordsData) requestMessage.getData();
			GaEncoderProcessingRealization.queryAlarmRecords(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_ALARM_RECORDS.getVal()) {

			RequestAlarmRecordsData data = (RequestAlarmRecordsData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteAlarmRecords(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.GET_K1_DEVICE_STATES.getVal()) {

			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1DeviceStates(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.GET_K1_KEYS_ID.getVal()) {

			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1KeysId(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.GET_K1_MEMBER.getVal()) {

			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1Member(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.ADD_K1_MEMBER.getVal()) {

			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.addK1Member(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_K1_MEMBER.getVal()) {

			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteK1Member(data, buf);
		}if (head.getControlType() == ControlTypeEnum.UPDATE_K1_MEMBER_NAME.getVal()) {

			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.updateK1MemberName(data, buf);
		}if (head.getControlType() == ControlTypeEnum.GET_K1_MEMBER_INFO.getVal()) {

			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1MemberInfo(data, buf);
		}if (head.getControlType() == ControlTypeEnum.ADD_K1_KEY.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.addK1Key(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DETETE_K1_KEY.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.deteteK1Key(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.UPDATE_K1_PASSWORD.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.updateK1Password(data, buf);
		}if (head.getControlType() == ControlTypeEnum.UPDATE_K1_FINGERPRINT_NAME.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.updateK1FingerprintName(data, buf);
		}if (head.getControlType() == ControlTypeEnum.GET_K1_RECORD_LIST.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1RecordList(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_K1_RECORD.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteK1Record(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.RELIEVE_ALARM.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.relieveAlarm(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.ADD_K1_TEM_PASSWORD.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.addK1TemPassword(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_K1_TEM_PASSWORD.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteK1TemPassword(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.GET_K1_TEM_PASSWORK_LIST.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1TemPassworkList(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.DELETE_TEM_PASSWORD_RECORDS.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.deleteTemPasswordRecords(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.GET_K1_INFOS.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1Infos(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.UPGRADE_K1_REQUEST.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.upgradeK1Request(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.VILIDATE_K1_PWD.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.vilidateK1Pwd(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.CONFIGUR_WIFI_INFO.getVal()) {
			RequestConfigurWIFIInfoData data = (RequestConfigurWIFIInfoData) requestMessage.getData();
			GaEncoderProcessingRealization.configurWIFIInfo(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.SEARCH_WIFI.getVal()) {
			RequestConfigurWIFIInfoData data = (RequestConfigurWIFIInfoData) requestMessage.getData();
			GaEncoderProcessingRealization.searchWifi(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.SET_3D_MODULE.getVal()) {
			Request3DModuleData data = (Request3DModuleData) requestMessage.getData();
			GaEncoderProcessingRealization.set3DModule(data, buf);
		}
		if (head.getControlType() == ControlTypeEnum.GET_K1_RECORD_LIST_3D.getVal()) {
			RequestK1DeviceData data = (RequestK1DeviceData) requestMessage.getData();
			GaEncoderProcessingRealization.getK1RecordList(data, buf);
		}
		
		
	}
}
