package com.b_noble.n_life.handler.processing;

import com.b_noble.n_life.BaseApplication;
import com.b_noble.n_life.event.AttrIdEnum;
import com.b_noble.n_life.event.ControlTypeEnum;
import com.b_noble.n_life.event.IrControlTypeEnum;
import com.b_noble.n_life.event.ResponseTypeEnum;
import com.b_noble.n_life.info.DeviceInfo;
import com.b_noble.n_life.utils.Global;
import com.b_noble.n_life.utils.Test16Binary;

import io.netty.buffer.ByteBuf;

/**
 * @公司 深圳市中泰智丰物联网科技有限公司
 * @项目 智能家居sdk
 * @简述 handler处理类
 * @作者 zhangfan
 * @date 2016-08-02
 * @版本 V0.0.1
 */
public class GaHandlerProcessing {

	public static void processing(int responseType, ByteBuf buf) {

		/**
		 * 获取网关信息返回处理
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_GATE_INFO.getVal()) {

			System.out.println("获取网关信息返回！！！！！！！！！");
			GaHandlerProcessingRealization.getGateinfoResponseProcessing(buf);
		}

		/**
		 * 获取所有设备返回处理
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_DEVICE.getVal()) {

			System.out.println("获取所有设备网关返回来了！！！！！！！！！！");
			GaHandlerProcessingRealization.getAllDeviceResponseProcessing(buf);

		}

		/**
		 * 设置设备开关状态返回处理
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_SET_DEVICE_STATE.getVal()) {

			System.out.println("设置设备开关网关返回来了！！！！！！！！！！");

		}

		/**
		 * 获取设备开关状态返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_DEVICE_STATE.getVal()) {

			System.out.println("获取设备开关网关返回来了！！！！！！！！！！");

			GaHandlerProcessingRealization.getDeviceStateResponseProcessing(buf);

		}

		/**
		 * 获取所有场景返回处理
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_SENCE.getVal()) {

			GaHandlerProcessingRealization.getAllSceneResponseProcessing(buf);

		}

		/**
		 * 添加场景返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_ADD_SENCE.getVal()) {
			System.out.println("添加场景网关返回来了！！！！！！！！！！");

			GaHandlerProcessingRealization.addSenceResponseProcessing(buf);

		}

		/**
		 * 调用场景返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_RECALL_SCENE.getVal()) {
			System.out.println("调用场景网关返回来了！！！！！！！！！！");
		}

		/**
		 * 删除场景返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_DELETE_SCENE.getVal()) {
			System.out.println("删除场景网关返回来了！！！！！！！！！！");
		}

		/**
		 * 增加任务返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_ADD_TASK.getVal()) {
			System.out.println("增加任务网关返回来了！！！！！！！！！！");
			
			GaHandlerProcessingRealization.addTaskResponseProcessing(buf);
		}

		/**
		 * 设置灯光亮度返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_SET_DEVICE_LEVEL.getVal()) {
			System.out.println("设置灯光亮度网关返回来了！！！！！！！！！！");
		}

		/**
		 * 设置设备颜色（饱和度/色调）返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_SET_DEVICE_HUE.getVal()) {
			System.out.println("设置灯光色调饱和度网关返回来了！！！！！！！！！！");
		}

		/**
		 * 设置设备色温返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_SET_COLOR_TEMPERATURE.getVal()) {
			System.out.println("设置灯光色温网关返回来了！！！！！！！！！！");
		}

		/**
		 * 删除指定任务返回
		 */
		/*if (responseType == ResponseTypeEnum.RESPONSE_DELETE_TASK.getVal()) {

			System.out.println("删除指定任务网关返回！！！！！！！！");
		}
*/
		/**
		 * 删除设备返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_DELETE_DEVICE.getVal()) {

			System.out.println("删除指定设备网关返回！！！！！！！！");
		}

		/**
		 * 更新设备名称返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_UPDATE_DEVICENAME.getVal()) {

			System.out.println("更新设备名称网关返回！！！！！！！");
			GaHandlerProcessingRealization.updateDeviceNameResponseProcessing(buf);
		}

		/**
		 * 获取设备亮度返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_DEVICE_LEVEL.getVal()) {

			System.out.println("获取设备亮度网关返回！！！！！！！");
			GaHandlerProcessingRealization.getDeviceLevelProcessing(buf);
		}

		/**
		 * 获取设备 色调与饱和度返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_DEVICE_HUE.getVal()) {

			System.out.println("获取设备色调与饱和度网关返回！！！！！！！");
			GaHandlerProcessingRealization.getDeviceHueProcessing(buf);
		}

		/**
		 * 获取设备 色温返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_DEVICE_COLORTEMPERATURE.getVal()) {

			System.out.println("获取设备色温网关返回！！！！！！！");
			GaHandlerProcessingRealization.getColorTemperatureProcessing(buf);
		}

		/**
		 * 更新场景名称
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_UPDATE_SCENENAME.getVal()) {

			System.out.println("更新场景名称网关返回！！！！！！！");
		}

		/**
		 * 获取场景成员
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_SENCE_DETAILED.getVal()) {

			System.out.println("获取场景成员返回！！！！！！");
			GaHandlerProcessingRealization.getSceneMemberProcessing(buf);
		}
		/**
		 * 删除指定场景成员
		 */
		/*if (responseType == ResponseTypeEnum.RESPONSE_DELETE_SENCE_MEMBER.getVal()) {

			System.out.println("删除指定场景成员返回！！！！！");
		}*/

		/**
		 * 将指定设备添加到场景中
		 */
		if (responseType == ResponseTypeEnum.REPOSNE_ADD_DEVICE_SENCE.getVal()) {
			System.out.println("添加设备到场景返回！！！！！");
		}

		/**
		 * 获取所有任务
		 */
		/*if (responseType == ResponseTypeEnum.REPOSNE_GET_ALL_TASK.getVal()) {
			System.out.println("获取所有任务返回！！！！！");
			GaHandlerProcessingRealization.getAllTaskProcessing(buf);
		}*/

		/**
		 * 获取定时任务详细
		 */
		if (responseType == ResponseTypeEnum.REPOSNE_GET_TASKINFO.getVal()) {
			System.out.println("获取任务详细返回！！！！！");
			GaHandlerProcessingRealization.getTaskInfoProcessing(buf);
		}

		/**
		 * 更新任务后返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_UPDATE_TASK.getVal()) {

			System.out.println("更新任务返回！！！！！！");
		}

		/**
		 * 获取指定场景任务返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_TASK_SCENE.getVal()) {
			GaHandlerProcessingRealization.getTaskBySceneId(buf);
		}

		/**
		 * 添加设备定时任务返回
		 *//*
		if (responseType == ResponseTypeEnum.RESPONSE_ADD_TIMING_TASK.getVal()) {

			System.out.println("添加设备定时任务返回！！！！！");
		}

		*//**
		 * 删除设备定时任务返回
		 *//*
		if (responseType == ResponseTypeEnum.RESPONSE_DELETE_TIMING_TASK.getVal()) {

			System.out.println("删除设备定时任务返回！！！！！");
		}
		*//**
		 * 更新设备定时任务返回
		 *//*
		if (responseType == ResponseTypeEnum.RESPONSE_UPDATE_TIMING_TASK.getVal()) {

			System.out.println("更新设备定时任务返回！！！！！");
		}*/

		/**
		 * 获取设备任务返回
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_TASK_DEVICE.getVal()) {
			
			GaHandlerProcessingRealization.getTaskByUid(buf);
		}
		
		/**
		 * 获取联动任务详细返回
		 */
		if (responseType == ControlTypeEnum.GET_LINKAGE_TASK_DETAILS.getVal()) {
			GaHandlerProcessingRealization.getLinkageTaskDetails(buf);
		}
		
		/**
		 * 获取指定场景联动任务列表返回
		 */
		/*if (responseType == ResponseTypeEnum.RESPONSE_GET_LINKAGE_SCENE.getVal()) {
			GaHandlerProcessingRealization.getLinkageScene(buf);
		}*/
		/**
		 * 获取指定设备联动任务列表返回
		 */
		/*if (responseType == ResponseTypeEnum.RESPONSE_GET_LINKAGE_DEVICE.getVal()) {
			GaHandlerProcessingRealization.getLinkageDevice(buf);
		}*/
		


		/**
		 * 获取心跳响应
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_SEND_HEARTBEAT.getVal()) {

			BaseApplication.getInstance().sendHeartbeat_CallBack();
		}
		
		/**
		 * 获取验证管理密码响应
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_VERIFICATION_MANAGERPWD.getVal()) {
			
			GaHandlerProcessingRealization.verificationManagerPwd(buf);
		}
		
		/**
		 * 获取密码响应
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_QUERY_PWD.getVal()) {
			GaHandlerProcessingRealization.queryPwd(buf);
		}
		
		/**
		 * 修改登录密码响应
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_MODIFY_PWD.getVal()) {
			
			GaHandlerProcessingRealization.modifyPwd(buf);
		}
		
		/**
		 * 修改管理密码响应
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_MODIFY_MANAGER_PWD.getVal()) {
			
			GaHandlerProcessingRealization.modifyManagerPwd(buf);
		}
		
		/**
		 * 局域网登录网关
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_LOGIN_LAN.getVal()) {
			
			GaHandlerProcessingRealization.loginGaByLan(buf);
		}
		
		/**
		 * 绑定网关
		 */
		if (responseType == ResponseTypeEnum.REPONSE_BIND_GA.getVal()) {
			
			GaHandlerProcessingRealization.bindGa(buf);
		}
		/**
		 * 添加用户
		 */
		if(responseType == ResponseTypeEnum.REPONSE_ADD_USER_GA.getVal()){
			GaHandlerProcessingRealization.addUserToGa(buf);
		}
		
		/**
		 * 上报新设备
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_REPORT_NEW_DEVICE.getVal()) {
			
			GaHandlerProcessingRealization.reportNewDevice(buf);
			BaseApplication.getInstance().responseReportNewDevice();
		}
		
		if(responseType == ResponseTypeEnum.RESPONSE_ENDPOINT_REPORT.getVal()){
			GaHandlerProcessingRealization.endpointReport(buf);
		}
		
		/**
		 * 添加区域
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_ADD_AREA.getVal()) {
			GaHandlerProcessingRealization.addArea(buf);
		}
		
		/**
		 * 获取区域详细
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_AREA_DETAILS.getVal()) {
			GaHandlerProcessingRealization.getAreaDetails(buf);
		}
		
		/**
		 * 获取所有区域
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_GET_ALL_AREA.getVal()) {
			GaHandlerProcessingRealization.getAllArea(buf);
		}
		
		/**
		 * 退出登录
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_SIGNOUT.getVal()) {
			BaseApplication.getInstance().signOut_callBack();
		}
		/**
		 * 未找到网关
		 */
		if (responseType == ResponseTypeEnum.NOT_FIND_GA.getVal()) {
			
			BaseApplication.getInstance().notFindGa_callback();
		}
		
		/**
		 * 未找到遥控器
		 */
		if (responseType == ResponseTypeEnum.NOT_FIND_IR.getVal()) {
			
			BaseApplication.getInstance().notFindIr_callback();
		}
		
		/**
		 * 查询窗帘电机状态
		 */
		if(responseType == ResponseTypeEnum.RESPONSE_QUERY_MOTOR_STATUS.getVal()){
			GaHandlerProcessingRealization.queryMotorStatus(buf);
		}
		
		/**
		 * 查询窗帘电机配置信息
		 */
		if(responseType == ResponseTypeEnum.RESPONSE_QUERY_ELECTRIC_INFO.getVal()){
			GaHandlerProcessingRealization.queryElectricInfo(buf);
		}
		
		/**
		 * 查询窗帘位置
		 */
		if(responseType == ResponseTypeEnum.RESPONSE_QUERY_CURTAIN_POSITION.getVal()){
			GaHandlerProcessingRealization.queryCurtainPosition(buf);
		}
		
		/**
		 * 查询门锁状态
		 */
		if(responseType == ResponseTypeEnum.RESPONSE_QUERY_DOORLOCK_SWITCH_STATE.getVal()){
			GaHandlerProcessingRealization.queryDoorlockSwitchState(buf);
		}
		
		/**
		 * 门锁操作通知推送
		 */
		if (responseType == ResponseTypeEnum.RESPONSE_OPERATION_EVENT_NOTIFICATION.getVal()){
			GaHandlerProcessingRealization.operationEventNotification(buf);
		}
		
		/**
		 * 查询门锁权限
		 *//*
		if (responseType == ResponseTypeEnum.RESPONSE_QUERY_PERMISSION_DOORLOCK.getVal()){
			GaHandlerProcessingRealization.queryPermissionDoorlock(buf);
		}*/
		
		/**
		 * 添加用户返回
		 */
		if (responseType == ControlTypeEnum.ADD_USER_TO_DOORLOCK.getVal()){
			GaHandlerProcessingRealization.addUserToDoorlock(buf);
		}
		
		/**
		 * 获取门锁用户列表
		 */
		if (responseType == ControlTypeEnum.QUERY_USER_INFO.getVal()){
			GaHandlerProcessingRealization.queryDoorUserInfos(buf);
		}
		
		/**
		 * 查询开锁记录
		 */
		if (responseType == ControlTypeEnum.QUERY_UNLOCK_RECORD.getVal()){
			GaHandlerProcessingRealization.queryUnlockRecord(buf);
		}
		/**
		 * 根据时间查询开锁记录
		 */
		if (responseType == ControlTypeEnum.QUERY_UNLOCK_RECORD_BY_TIME.getVal()){
			GaHandlerProcessingRealization.queryUnlockRecord(buf);
		}
		
		/**
		 * 查询开锁异常记录
		 */
		if (responseType == ControlTypeEnum.QUERY_ABNORMAL_RECORD.getVal()){
			GaHandlerProcessingRealization.queryAbnormalRecord(buf);
		}
		/**
		 * 根据时间查询开锁异常记录
		 */
		if (responseType == ControlTypeEnum.QUERY_ABNORMAL_RECORD_BY_TIME.getVal()){
			GaHandlerProcessingRealization.queryAbnormalRecord(buf);
		}
		/**
		 * 异常通知
		 */
		if (responseType == ControlTypeEnum.ABNORMAL_EVENT_NOTIFICATION.getVal()){
			GaHandlerProcessingRealization.abnormalEventNotification(buf);
		}
		
		
		
		if (responseType == ResponseTypeEnum.RESPONSE_REQUEST_GATE_ZIGBEE_VERSION.getVal()){
			GaHandlerProcessingRealization.requestGaOrZigbeeVersion(buf);
		}
		
		if (responseType == ResponseTypeEnum.RESPONSE_REPORT_UPGRADE_STATUS.getVal()){
			GaHandlerProcessingRealization.report_upgrade_status(buf);
		}
		if (responseType == ControlTypeEnum.BIND_DEVICE.getVal()){
			GaHandlerProcessingRealization.requestTemperatureAndHumidity(buf);
		}
		if (responseType == IrControlTypeEnum.GET_ONLINESTATUS_OF_CLIENT.getVal()){
			GaHandlerProcessingRealization.getTheOnlineStatusOfThClient(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_DOORLOCK_ELECTRICITY.getVal()){
			GaHandlerProcessingRealization.queryDoorlockElectricity(buf);
		}
		if (responseType == ControlTypeEnum.CURTAIN_STROKE_CONTROL.getVal()){
			GaHandlerProcessingRealization.curtainStrokeControl(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_USER_TO_DOORLOCK.getVal()){
			GaHandlerProcessingRealization.deleteUserToDoorlock(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_UNLOCK_RECORD.getVal()){
			GaHandlerProcessingRealization.deleteUnlockRecord(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_SENCE.getVal()){
			GaHandlerProcessingRealization.deleteSence(buf);
		}
		if (responseType == ControlTypeEnum.UPDATE_SENCE_NAME.getVal()){
			GaHandlerProcessingRealization.ChangeSceneName(buf);
		}
		if (responseType == ControlTypeEnum.MODITY_SCENE.getVal()){
			GaHandlerProcessingRealization.modifyScene(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_TASK.getVal()){
			GaHandlerProcessingRealization.deleteTask(buf);
		}
		if (responseType == ControlTypeEnum.MODITY_TASK.getVal()){
			GaHandlerProcessingRealization.updateTimerTask(buf);
		}
		if (responseType == ControlTypeEnum.UPDATE_TASK_NAME.getVal()){
			GaHandlerProcessingRealization.updateTaskName(buf);
		}
		if (responseType == ControlTypeEnum.GET_TIMER_TASK.getVal()){
			GaHandlerProcessingRealization.getTimerTask(buf);
		}
		if (responseType == ControlTypeEnum.ADD_LINKAGE_TASK.getVal()){
			GaHandlerProcessingRealization.addLinkageTask(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_LINKAGE_TASK.getVal()){
			GaHandlerProcessingRealization.deleteLinkageTask(buf);
		}
		if (responseType == ControlTypeEnum.MODITY_LINKAGE_TASK.getVal()){
			GaHandlerProcessingRealization.modityLinkageTask(buf);
		}
		if (responseType == ControlTypeEnum.UPDATE_LINKAGE_NAME.getVal()){
			GaHandlerProcessingRealization.updateLinkageName(buf);
		}
		if (responseType == ControlTypeEnum.UPDATE_LINKAGE_STATUS.getVal()){
			GaHandlerProcessingRealization.updateLinkageStutus(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_ALL_LINKAGE.getVal()){
			GaHandlerProcessingRealization.queryAllGaLinkage(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_LINKAGE_UID.getVal()){
			GaHandlerProcessingRealization.queryGaLinkageByUid(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_DEVICE.getVal()){
			GaHandlerProcessingRealization.deleteDevice(buf);
		}
		if (responseType == ControlTypeEnum.DEVICE_KEY_CONFIGURE.getVal()){
			GaHandlerProcessingRealization.deviceKeyConfigure(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_CONFIGURE_OF_DEVICEKEY.getVal()){
			GaHandlerProcessingRealization.deleteConfigureOfDeviceKey(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_ALL_CONFIGURE_OF_THE_DEVICE.getVal()){
			GaHandlerProcessingRealization.queryAllConfigureOfTheDevice(buf);
		}
		if (responseType == ControlTypeEnum.SET_THE_THERMOSTAT_MODE.getVal()){
			GaHandlerProcessingRealization.setTheThermostatMode(buf);
		}
		if (responseType == ControlTypeEnum.SET_THE_WIND_SPEED.getVal()){
			GaHandlerProcessingRealization.setTheWindSpeed(buf);
		}
		if (responseType == ControlTypeEnum.ADJUSTT_THE_TEMPERATURE.getVal()){
			GaHandlerProcessingRealization.adjusttTheTemperature(buf);
		}
		if (responseType == ControlTypeEnum.SET_THE_RUN_MODE_THAT_POWERRESUME.getVal()){
			GaHandlerProcessingRealization.setTheRunModeThatPowerResume(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_THE_THERMOSTAT_CONFIGUREINFO.getVal()){
			GaHandlerProcessingRealization.queryTheThermostatConfigureInfo(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_THE_THERMOSTAT_RUN_STATUS.getVal()){
			GaHandlerProcessingRealization.queryTheThermostatRunStatus(buf);
		}
		if (responseType == ControlTypeEnum.SET_THE_THERMOSTAT_STATE.getVal()){
			GaHandlerProcessingRealization.setThermostatState(buf);
		}
		if (responseType == ControlTypeEnum.SET_DOORLOCK_SWITCHSTATE.getVal()){
			GaHandlerProcessingRealization.setDoorlockSwitchState(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_GYDOORLOCK_SWITCHSTATE.getVal()){
			GaHandlerProcessingRealization.queryGyDoorlockSwitchState(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_DOORLOCK_RECENT_STATUS.getVal()){
			GaHandlerProcessingRealization.queryDoorlockRecentStatus(buf);
		}
		if (responseType == ControlTypeEnum.QUERY_ALL_LOCKUSER_INFO.getVal()){
			GaHandlerProcessingRealization.queryAllLockUserInfo(buf);
		}if (responseType == ControlTypeEnum.DOORLOCK_EVENT_PUSH.getVal()){
			GaHandlerProcessingRealization.doorlockEventPush(buf);
		}if (responseType == ControlTypeEnum.QUERY_LOCK_MACHINE_CODE.getVal()){
			GaHandlerProcessingRealization.queryLockMachineCode(buf);
		}
		if (responseType == ControlTypeEnum.BIND_DDEVICE.getVal()){
			GaHandlerProcessingRealization.bindDevice(buf);
		}if (responseType == ControlTypeEnum.CANCEL_BIND.getVal()){
			GaHandlerProcessingRealization.cancelBind(buf);
		}if (responseType == ControlTypeEnum.QUERY_ALL_BIND.getVal()){
			GaHandlerProcessingRealization.queryAllBind(buf);
		}if (responseType == ControlTypeEnum.QUERY_ALARM_RECORDS.getVal()){
			GaHandlerProcessingRealization.queryAlarmRecords(buf);
		}if (responseType == ControlTypeEnum.DEVICE_EMERGENCY_ALARM_PUSH.getVal()){
			GaHandlerProcessingRealization.deviceEmergencyAlarmPush(buf);
		}if (responseType == ControlTypeEnum.GET_K1_DEVICE_STATES.getVal()){
			GaHandlerProcessingRealization.getK1DeviceStates(buf);
		}if (responseType == ControlTypeEnum.REPORT_K1_STATE.getVal()){
			GaHandlerProcessingRealization.reportk1State(buf);
		}if (responseType == ControlTypeEnum.REPORT_K1_ABNORMAL.getVal()){
			GaHandlerProcessingRealization.reportK1Abnormal(buf);
		}if (responseType == ControlTypeEnum.GET_K1_KEYS_ID.getVal()){
			GaHandlerProcessingRealization.getK1KeysId(buf);
		}if (responseType == ControlTypeEnum.GET_K1_MEMBER.getVal()){
			GaHandlerProcessingRealization.getK1Member(buf);
		}
		if (responseType == ControlTypeEnum.ADD_K1_MEMBER.getVal()){
			GaHandlerProcessingRealization.addK1Member(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_K1_MEMBER.getVal()){
			GaHandlerProcessingRealization.deleteK1Member(buf);
		}
		if (responseType == ControlTypeEnum.UPDATE_K1_MEMBER_NAME.getVal()){
			GaHandlerProcessingRealization.updateK1MemberName(buf);
		}
		if (responseType == ControlTypeEnum.GET_K1_MEMBER_INFO.getVal()){
			GaHandlerProcessingRealization.getK1MemberInfo(buf);
		}
		if (responseType == ControlTypeEnum.ADD_K1_KEY.getVal()){
			GaHandlerProcessingRealization.addK1Key(buf);
		}
		if (responseType == ControlTypeEnum.REPORT_FINGERPRINT_STATE.getVal()){
			GaHandlerProcessingRealization.reportFingerprintState(buf);
		}
		if (responseType == ControlTypeEnum.DETETE_K1_KEY.getVal()){
			GaHandlerProcessingRealization.deteteK1Key(buf);
		}
		if (responseType == ControlTypeEnum.UPDATE_K1_PASSWORD.getVal()){
			GaHandlerProcessingRealization.updateK1Password(buf);
		}
		if (responseType == ControlTypeEnum.UPDATE_K1_FINGERPRINT_NAME.getVal()){
			GaHandlerProcessingRealization.updateK1FingerprintName(buf);
		}
		if (responseType == ControlTypeEnum.GET_K1_RECORD_LIST.getVal()){
			GaHandlerProcessingRealization.getK1RecordList(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_K1_RECORD.getVal()){
			GaHandlerProcessingRealization.deleteK1Record(buf);
		}
		if (responseType == ControlTypeEnum.RELIEVE_ALARM.getVal()){
			GaHandlerProcessingRealization.relieveAlarm(buf);
		}
		if (responseType == ControlTypeEnum.ADD_K1_TEM_PASSWORD.getVal()){
			GaHandlerProcessingRealization.addK1TemPassword(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_K1_TEM_PASSWORD.getVal()){
			GaHandlerProcessingRealization.deleteK1TemPassword(buf);
		}
		if (responseType == ControlTypeEnum.GET_K1_TEM_PASSWORK_LIST.getVal()){
			GaHandlerProcessingRealization.getK1TemPassworkList(buf);
		}
		if (responseType == ControlTypeEnum.DELETE_TEM_PASSWORD_RECORDS.getVal()){
			GaHandlerProcessingRealization.deleteTemPasswordRecords(buf);
		}
		if (responseType == ControlTypeEnum.REPORT_HIJACK.getVal()){
			GaHandlerProcessingRealization.reportHijack(buf);
		}
		if (responseType == ControlTypeEnum.GET_K1_INFOS.getVal()){
			GaHandlerProcessingRealization.getK1Infos(buf);
		}
		if (responseType == ControlTypeEnum.UPGRADE_K1_REQUEST.getVal()){
			GaHandlerProcessingRealization.upgradeK1Request(buf);
		}
		if (responseType == ControlTypeEnum.REPORT_UPGRADE_K1.getVal()){
			GaHandlerProcessingRealization.reportUpgradeK1(buf);
		}if (responseType == ControlTypeEnum.VILIDATE_K1_PWD.getVal()){
			GaHandlerProcessingRealization.vilidateK1Pwd(buf);
		}if (responseType == ControlTypeEnum.CONFIGUR_WIFI_INFO.getVal()){
			GaHandlerProcessingRealization.configurWIFIInfo(buf);
		}if (responseType == ControlTypeEnum.SEARCH_WIFI.getVal()){
			GaHandlerProcessingRealization.searchWifi(buf);
		}if (responseType == ControlTypeEnum.REPORT_UPGRADE_SPEED.getVal()){
			GaHandlerProcessingRealization.reportUpgradeSpeed(buf);
		}if (responseType == 0x15){
			GaHandlerProcessingRealization.m1notic(buf);
		}if (responseType == ControlTypeEnum.SET_3D_MODULE.getVal()){
			GaHandlerProcessingRealization.set3DModule(buf);
		}
		if (responseType == ControlTypeEnum.GET_K1_RECORD_LIST_3D.getVal()){
			GaHandlerProcessingRealization.getK1RecordListAnd3d(buf);
		}





	}

	


}
