package com.b_noble.n_life.handler.processing;

import com.b_noble.n_life.event.IrControlTypeEnum;
import com.b_noble.n_life.info.IrLinkageInfo;
import com.b_noble.n_life.model.RequestCustomRemoteControlData;
import com.b_noble.n_life.model.RequestGetIrDeviceInfoData;
import com.b_noble.n_life.model.RequestGetTheOnlineStatusOfThClientData;
import com.b_noble.n_life.model.RequestHead;
import com.b_noble.n_life.model.RequestIrDeviceSwitchStateData;
import com.b_noble.n_life.model.RequestIrLigthBrightnessData;
import com.b_noble.n_life.model.RequestIrLigthHueAndSatData;
import com.b_noble.n_life.model.RequestIrModeData;
import com.b_noble.n_life.model.RequestIrTaskData;
import com.b_noble.n_life.model.RequestLinkageDetailsData;
import com.b_noble.n_life.model.RequestMessage;
import com.b_noble.n_life.model.RequestRemoveIrDeviceData;
import com.b_noble.n_life.model.RequestReportNewDeviceData;
import com.b_noble.n_life.model.RequestRequireRICodeData;
import com.b_noble.n_life.model.RequestResetRemoteControlData;
import com.b_noble.n_life.model.RequestSmartModeData;
import com.b_noble.n_life.model.RequestTHInformationData;
import com.b_noble.n_life.model.RequestToUpgradeData;
import com.b_noble.n_life.model.RequestUpdateIrDeviceNameData;
import com.b_noble.n_life.model.RequestWifiNetworkInformationData;

import io.netty.buffer.ByteBuf;

/**
 * 公司：深圳市中泰智丰物联网科技有限公司 项目：智能家居 简述：编码处理类 作者：zhangfan 时间：2016-08-02 版本：V0.0.1
 */
public class IrEncoderProcessing {

	public static void processing(RequestMessage requestMessage, ByteBuf buf) {

		RequestHead head = requestMessage.getHeader();

		/**
		 * 查询所有设备
		 */
		if (head.getControlType() == IrControlTypeEnum.QUIRYIR_ALL_DEVICE.getVal()) {
			
			IrEncoderProcessingRealization.quiryIrAllDevice(buf);
		}
		
		/**
		 * 获取指定设备信息
		 */
		if(head.getControlType() == IrControlTypeEnum.REQUEST_DEVICE_INFORMATION.getVal()){
			
			RequestGetIrDeviceInfoData data = (RequestGetIrDeviceInfoData) requestMessage.getData();
			IrEncoderProcessingRealization.getIrDeviceInfo(data,buf);
		}
		
		/**
		 * 设置指定设备开关状态
		 */
		if(head.getControlType() == IrControlTypeEnum.SET_DEVICE_SWITCH_STATE.getVal()){
			
			RequestIrDeviceSwitchStateData data = (RequestIrDeviceSwitchStateData) requestMessage.getData();
			IrEncoderProcessingRealization.setIrDeviceSwitchState(data,buf);
		}
		
		/**
		 * 获取指定设备开关状态
		 */
		if(head.getControlType() == IrControlTypeEnum.GET_DEVICE_SWITCH_STATE.getVal()){
			
			RequestIrDeviceSwitchStateData data = (RequestIrDeviceSwitchStateData) requestMessage.getData();
			IrEncoderProcessingRealization.getIrDeviceSwitchState(data,buf);
		}
		
		/**
		 * 设置灯亮度
		 */
		if(head.getControlType() == IrControlTypeEnum.SET_LIGHT_BRIGHTNESS.getVal()){
			
			RequestIrLigthBrightnessData data = (RequestIrLigthBrightnessData) requestMessage.getData();
			IrEncoderProcessingRealization.setIrLigthBrightness(data,buf);
		}
		
		/**
		 * 获取灯亮度
		 */
		if(head.getControlType() == IrControlTypeEnum.GET_LIGHT_BRIGHTNESS.getVal()){
			
			RequestIrLigthBrightnessData data = (RequestIrLigthBrightnessData) requestMessage.getData();
			IrEncoderProcessingRealization.getIrLigthBrightness(data,buf);
		}
		

		if(head.getControlType() == IrControlTypeEnum.SET_LIGHTHUE_OR_SATURATION.getVal()){
			
			RequestIrLigthHueAndSatData data = (RequestIrLigthHueAndSatData) requestMessage.getData();
			IrEncoderProcessingRealization.setIrLigthHueAndSat(data,buf);
		}
		
		if(head.getControlType() == IrControlTypeEnum.GET_LIGHTHUE_OR_SATURATION.getVal()){
			
			RequestIrLigthHueAndSatData data = (RequestIrLigthHueAndSatData) requestMessage.getData();
			IrEncoderProcessingRealization.getIrLigthHueAndSat(data,buf);
		}
		
		
		if(head.getControlType() == IrControlTypeEnum.SET_LAMP_SENSING_MODE.getVal()){
			
			RequestIrModeData data = (RequestIrModeData) requestMessage.getData();
			IrEncoderProcessingRealization.setLampSensingMode(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.SET_LIGHT_AMBILIGHT_MODE.getVal()){
			
			RequestIrModeData data = (RequestIrModeData) requestMessage.getData();
			IrEncoderProcessingRealization.setLightAmbilightMode(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REQUIRE_REMOTE_CONTROL_INFRARED_CODE.getVal()){
			
			RequestRequireRICodeData data = (RequestRequireRICodeData) requestMessage.getData();
			IrEncoderProcessingRealization.requireRemoteControlInfraredCode(data,buf);
		}
		
		if(head.getControlType() == IrControlTypeEnum.QUERY_ALL_IRTASK.getVal()){
			
			IrEncoderProcessingRealization.queryAllIrTask(buf);
		}
		
		if(head.getControlType() == IrControlTypeEnum.ADD_IRTASK.getVal()){
			
			RequestIrTaskData data = (RequestIrTaskData)requestMessage.getData();
			IrEncoderProcessingRealization.addIrTask(data,buf);
		}
		
		if(head.getControlType() == IrControlTypeEnum.DELETE_IRTASK.getVal()){
			
			RequestIrTaskData data = (RequestIrTaskData)requestMessage.getData();
			IrEncoderProcessingRealization.deleteIrTask(data,buf);
		}
		
		if(head.getControlType() == IrControlTypeEnum.UPDATE_IRTASK.getVal()){
			
			RequestIrTaskData data = (RequestIrTaskData)requestMessage.getData();
			IrEncoderProcessingRealization.updateIrTask(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.QUERY_TASKINFO_TASKID.getVal()){
			
			RequestIrTaskData data = (RequestIrTaskData)requestMessage.getData();
			IrEncoderProcessingRealization.queryIrTaskInfo(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.QUERY_ALL_TASKINFO.getVal()){
			
			IrEncoderProcessingRealization.queryAllIrtaskInfo(buf);
		}
		if(head.getControlType() == IrControlTypeEnum.QUERY_TASKINFO_DEVICE.getVal()){
			
			IrEncoderProcessingRealization.queryIrTaskInfoByDevice(buf);
		}
		if(head.getControlType() == IrControlTypeEnum.UPDATE_IRTASK_STATE.getVal()){
			RequestIrTaskData data = (RequestIrTaskData)requestMessage.getData();
			IrEncoderProcessingRealization.updateIrTaskState(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.GET_REMOTECONTROL_INFORMATION.getVal()){
			IrEncoderProcessingRealization.getRemoteControlInformation(buf);
		}
		if(head.getControlType() == IrControlTypeEnum.SET_WIFI_NETWORK_INFORMATION.getVal()){
			RequestWifiNetworkInformationData data = (RequestWifiNetworkInformationData)requestMessage.getData();
			IrEncoderProcessingRealization.setWifiNetworkInformation(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REQUEST_WIFI_NETWORK_INFORMATION.getVal()){
			IrEncoderProcessingRealization.requestWifiNetworkInformation(buf);
		}
		if(head.getControlType() == IrControlTypeEnum.RESET_REMOTE_CONTROL.getVal()){
			
			RequestResetRemoteControlData data = (RequestResetRemoteControlData) requestMessage.getData();
			IrEncoderProcessingRealization.resetRemoteControl(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REQUEST_TEMPERATURE_INFORMATION.getVal()){
			RequestTHInformationData data = (RequestTHInformationData)requestMessage.getData();
			IrEncoderProcessingRealization.requestTemperatureInformation(data,buf);
		}
		
		if(head.getControlType() == IrControlTypeEnum.REQUEST_HUMIDITY_INFORMATION.getVal()){
			RequestTHInformationData data = (RequestTHInformationData)requestMessage.getData();
			IrEncoderProcessingRealization.requestHumidityInformation(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REPORT_NEW_DEVICE.getVal()){
			RequestReportNewDeviceData data = (RequestReportNewDeviceData)requestMessage.getData();
			IrEncoderProcessingRealization.reportNewDevice(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REMOVE_IR_DEVICE.getVal()){
			RequestRemoveIrDeviceData data = (RequestRemoveIrDeviceData)requestMessage.getData();
			IrEncoderProcessingRealization.removeIrDevice(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.UPDATE_DEVICE_NAME.getVal()){
			RequestUpdateIrDeviceNameData data = (RequestUpdateIrDeviceNameData)requestMessage.getData();
			IrEncoderProcessingRealization.updateIrDeviceName(data,buf);
		}
		
		if(head.getControlType() == IrControlTypeEnum.ADD_LINKAGE.getVal()){
			IrLinkageInfo data = (IrLinkageInfo)requestMessage.getData();
			IrEncoderProcessingRealization.addIrLinkage(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.QUERY_ALL_LINKAGE.getVal()){
			IrEncoderProcessingRealization.queryAllLinkage(buf);
		}
		if(head.getControlType() == IrControlTypeEnum.QUERY_LINKAGE_DETAILS.getVal()){
			RequestLinkageDetailsData data = (RequestLinkageDetailsData)requestMessage.getData();
			IrEncoderProcessingRealization.queryLinkageDetails(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.DELETE_LINKAGE.getVal()){
			RequestLinkageDetailsData data = (RequestLinkageDetailsData)requestMessage.getData();
			IrEncoderProcessingRealization.deleteLinkage(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.SET_SMART_MODE.getVal()){
			RequestSmartModeData data = (RequestSmartModeData)requestMessage.getData();
			IrEncoderProcessingRealization.setSmartMode(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.SET_SMART_MODE_LOW_TEMPERATURE_CMD.getVal()){
			RequestSmartModeData data = (RequestSmartModeData)requestMessage.getData();
			IrEncoderProcessingRealization.setSmartModeLowTemperatureCmd(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.SET_SMART_MODE_HIGH_TEMPERATURE_CMD.getVal()){
			RequestSmartModeData data = (RequestSmartModeData)requestMessage.getData();
			IrEncoderProcessingRealization.setSmartModeHighTemperatureCmd(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.QUERY_THE_SMART_MODE.getVal()){
			IrEncoderProcessingRealization.querySmartMode(buf);
		}
		if(head.getControlType() == IrControlTypeEnum.UPDATE_SMART_STATE.getVal()){
			RequestSmartModeData data = (RequestSmartModeData)requestMessage.getData();
			IrEncoderProcessingRealization.updateSmartState(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REQUEST_REMOTECONTROL_VERSION.getVal()){
			IrEncoderProcessingRealization.requestRemoteControlVersion(buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REQUEST_TO_UPGRADE.getVal()){
			RequestToUpgradeData data = (RequestToUpgradeData)requestMessage.getData();
			IrEncoderProcessingRealization.requestToUpgrade(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.CUSTOM_REMOTE_CONTROL_KEYS.getVal()){
			RequestCustomRemoteControlData data = (RequestCustomRemoteControlData)requestMessage.getData();
			IrEncoderProcessingRealization.customRemoteControlKeys(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REQUEST_CUSTOM_REMOTE_CONTROL_BY_DEVICEADDR_AND_PROFILEID.getVal()){
			RequestCustomRemoteControlData data = (RequestCustomRemoteControlData)requestMessage.getData();
			IrEncoderProcessingRealization.requestCustomRemoteControlByDevice(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.SEND_CUSTOM_REMOTE_CONTROL_KEY.getVal()){
			RequestCustomRemoteControlData data = (RequestCustomRemoteControlData)requestMessage.getData();
			IrEncoderProcessingRealization.sendCustomRemoteControlKey(data,buf);
		}
		if(head.getControlType() == IrControlTypeEnum.REQUEST_REMOTE_CONTROL_FIRMWARE_LENGTH.getVal()){
			RequestToUpgradeData data = (RequestToUpgradeData)requestMessage.getData();
			IrEncoderProcessingRealization.requestRemoteControlFirmwareLength(data,buf);
		}
		if (head.getControlType() == IrControlTypeEnum.GET_ONLINESTATUS_OF_CLIENT.getVal()) {
			
			RequestGetTheOnlineStatusOfThClientData data = (RequestGetTheOnlineStatusOfThClientData) requestMessage.getData();
			GaEncoderProcessingRealization.getTheOnlineStatusOfThClient(data,buf);
		}

	}
}
