package com.b_noble.n_life.handler.processing;

import com.b_noble.n_life.BaseApplication;
import com.b_noble.n_life.event.AttrIdEnum;
import com.b_noble.n_life.event.IrControlTypeEnum;
import com.b_noble.n_life.event.ResponseTypeEnum;
import com.b_noble.n_life.info.DeviceInfo;
import com.b_noble.n_life.utils.Global;
import com.b_noble.n_life.utils.Test16Binary;

import io.netty.buffer.ByteBuf;

/**
 * @公司 深圳市中泰智丰物联网科技有限公司
 * @项目 智能家居sdk
 * @简述 handler处理类
 * @作者 zhangfan
 * @date 2016-08-02
 * @版本 V0.0.1
 */
public class IrHandlerProcessing {

	public static void processing(int responseType, ByteBuf buf,byte[] sn) {

		/**
		 * 获取遥控器所有设备
		 */
		if (responseType == IrControlTypeEnum.QUIRYIR_ALL_DEVICE.getVal()) {

			IrHandlerProcessingRealization.quiryIrAllDevice(buf,sn);
		}
		
		/**
		 * 获取指定设备信息
		 */
		if (responseType == IrControlTypeEnum.REQUEST_DEVICE_INFORMATION.getVal()) {

			IrHandlerProcessingRealization.getIrDeviceInfo(buf,sn);
		}
		
		/**
		 * 获取指定设备的开关状态
		 */
		if (responseType == IrControlTypeEnum.GET_DEVICE_SWITCH_STATE.getVal()) {

			IrHandlerProcessingRealization.getIrDeviceSwitchState(buf,sn);
		}
		
		/**
		 * 获取灯的亮度
		 */
		if (responseType == IrControlTypeEnum.GET_LIGHT_BRIGHTNESS.getVal()) {
			IrHandlerProcessingRealization.getIrLigthBrightness(buf,sn);
		}
		
		/**
		 * 获取灯的色调饱和度
		 */
		if (responseType == IrControlTypeEnum.GET_LIGHTHUE_OR_SATURATION.getVal()) {
			IrHandlerProcessingRealization.getIrLigthHueAndSat(buf);
		}
		
		/**
		 * 查询所有任务名称列表
		 */
		if (responseType == IrControlTypeEnum.QUERY_ALL_IRTASK.getVal()) {
			IrHandlerProcessingRealization.queryAllIrTask(buf,sn);
		}
		
		/**
		 * 查询指定任务详细
		 */
		if (responseType == IrControlTypeEnum.QUERY_TASKINFO_TASKID.getVal()) {
			IrHandlerProcessingRealization.queryIrTaskInfo(buf,sn);
		}
		
		/**
		 * 查询所有定时任务详细
		 */
		if (responseType == IrControlTypeEnum.QUERY_ALL_TASKINFO.getVal()) {
			IrHandlerProcessingRealization.queryAllIrtaskInfo(buf);
		}
		
		
		/**
		 * 获取遥控器信息
		 */
		if (responseType == IrControlTypeEnum.GET_REMOTECONTROL_INFORMATION.getVal()) {
			IrHandlerProcessingRealization.getRemoteControlInformation(buf);
		}
		
		/**
		 * 获取wifi信息
		 */
		if (responseType == IrControlTypeEnum.REQUEST_WIFI_NETWORK_INFORMATION.getVal()) {
			IrHandlerProcessingRealization.requestWifiNetworkInformation(buf);
		}

		if (responseType == IrControlTypeEnum.REQUEST_TEMPERATURE_INFORMATION.getVal()) {
			IrHandlerProcessingRealization.requestTemperatureInformation(buf);
		}
		
		if (responseType == IrControlTypeEnum.REQUEST_HUMIDITY_INFORMATION.getVal()) {
			IrHandlerProcessingRealization.requestHumidityInformation(buf);
		}
		
		if (responseType == IrControlTypeEnum.QUERY_ALL_LINKAGE.getVal()) {
			IrHandlerProcessingRealization.queryAllLinkage(buf);
		}
		if (responseType == IrControlTypeEnum.QUERY_LINKAGE_DETAILS.getVal()) {
			IrHandlerProcessingRealization.queryLinkageDetails(buf);
		}
		if (responseType == IrControlTypeEnum.QUERY_THE_SMART_MODE.getVal()) {
			IrHandlerProcessingRealization.querySmartMode(buf);
		}
		if (responseType == IrControlTypeEnum.REQUEST_REMOTECONTROL_VERSION.getVal()) {
			IrHandlerProcessingRealization.requestRemoteControlVersion(buf);
		}
		if (responseType == IrControlTypeEnum.REQUEST_CUSTOM_REMOTE_CONTROL_BY_DEVICEADDR_AND_PROFILEID.getVal()) {
			IrHandlerProcessingRealization.requestCustomRemoteControlByDevice(buf);
		}
		if (responseType == IrControlTypeEnum.CUSTOM_REMOTE_CONTROL_KEYS.getVal()) {
			IrHandlerProcessingRealization.customRemoteControlKeys(buf);
		}
		if (responseType == IrControlTypeEnum.REQUEST_REMOTE_CONTROL_FIRMWARE_LENGTH.getVal()) {
			IrHandlerProcessingRealization.requestRemoteControlFirmwareLength(buf);
		}
		if (responseType == IrControlTypeEnum.REPORT_NEW_DEVICE.getVal()) {
			IrHandlerProcessingRealization.reportNewDevice(buf);
		}
		if (responseType == IrControlTypeEnum.UPGRADE_OK.getVal()) {
			IrHandlerProcessingRealization.upgradeOk(buf);
		}
		if (responseType == IrControlTypeEnum.REMOVE_IR_DEVICE.getVal()) {
			IrHandlerProcessingRealization.removeIrDevice(buf);
		}
		if (responseType == IrControlTypeEnum.UPDATE_DEVICE_NAME.getVal()) {
			IrHandlerProcessingRealization.updateIrDeviceName(buf);
		}
		if(responseType == IrControlTypeEnum.ADD_IRTASK.getVal()){
			
			IrHandlerProcessingRealization.addIrTask(buf);
		}
		if (responseType == IrControlTypeEnum.GET_ONLINESTATUS_OF_CLIENT.getVal()){
			GaHandlerProcessingRealization.getTheOnlineStatusOfThClient(buf);
		}

		
		

	}

	


}
