package com.b_noble.n_life.handler.processing;

import java.io.UnsupportedEncodingException;

import com.b_noble.n_life.model.RequestAddWifiTaskData;
import com.b_noble.n_life.model.RequestConfigurationElectricMotorData;
import com.b_noble.n_life.model.RequestOpenOrCloseCurtainData;
import com.b_noble.n_life.model.RequestRollingBlindData;
import com.b_noble.n_life.model.RequestSetColorTemperatureData;
import com.b_noble.n_life.model.RequestSetDeviceColorData;
import com.b_noble.n_life.model.RequestSetDeviceLevelData;
import com.b_noble.n_life.model.RequestSetDeviceStateData;
import com.b_noble.n_life.model.RequestSetDlectricMotorDirectionData;
import com.b_noble.n_life.model.RequestUpgradeDate;
import com.b_noble.n_life.model.RequestWifiNetworkInformationData;

import io.netty.buffer.ByteBuf;

public class WifiEncoderProcessingRealization {

	public static void getWifiModuleInformation(ByteBuf buf) {
		// state
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void setWifiModuleWifiNetworkInformation(ByteBuf buf, RequestWifiNetworkInformationData data) {

		// state
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		try {
			buf.writeBytes(data.getSsid().getBytes("gbk"));
			for (int i = 0; i < 32 - data.getSsid().getBytes("gbk").length; i++) {
				buf.writeByte(0x00);
			}
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		try {
			buf.writeBytes(data.getPwd().getBytes("gbk"));
			for (int i = 0; i < 32 - data.getPwd().getBytes("gbk").length; i++) {
				buf.writeByte(0x00);
			}
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void requestWifiModuleWifiNetworkInformation(ByteBuf buf) {
		// TODO Auto-generated method stub
		// state
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void upgradeOrResetWifiModule(ByteBuf buf, RequestUpgradeDate data) {
		// TODO Auto-generated method stub
		// state
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(data.getCommand());

		buf.writeShort(data.getVersion());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void switchOnlineStateOfWifiModule(ByteBuf buf, RequestSetDeviceStateData data) {
		// TODO Auto-generated method stub
		// state
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(data.getState());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void getModuleAllDevice(ByteBuf buf) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);
		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}

	}

	public static void requestWifiModuleVersion(ByteBuf buf, RequestUpgradeDate data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(data.getCommand());
		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void setWifiModuleIntoTheNetworkMode(ByteBuf buf) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void setWifiDeviceSwitchState(ByteBuf buf, RequestSetDeviceStateData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		buf.writeByte(data.getState());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void requireWifiDeviceSwitchState(ByteBuf buf, RequestSetDeviceStateData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void setWifiLightBrightness(ByteBuf buf, RequestSetDeviceLevelData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		buf.writeByte(data.getLevelValue());

		buf.writeShort(data.getSwitchTime());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void requireWifiLightBrightness(ByteBuf buf, RequestSetDeviceLevelData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void setWifiLighthueOrSaturation(ByteBuf buf, RequestSetDeviceColorData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		buf.writeByte(data.getHue());

		buf.writeByte(data.getSat());

		buf.writeShort(data.getSwitchTime());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void requireWifiLighthueOrSaturation(ByteBuf buf, RequestSetDeviceColorData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void setWifiLightColorTemperature(ByteBuf buf, RequestSetColorTemperatureData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		buf.writeShort(data.getColorTemperature());

		buf.writeShort(data.getSwitchTime());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void requireWifiLightColorTemperature(ByteBuf buf, RequestSetColorTemperatureData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void setWifiElectricMotorDirection(ByteBuf buf, RequestSetDlectricMotorDirectionData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		buf.writeByte(data.getDirection());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void configurationWifiElectricMotor(ByteBuf buf, RequestConfigurationElectricMotorData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// value
		if (data.getHandPull() == 0 && data.getLinkage() == 0) {
			buf.writeByte(0x00);
		} else if (data.getHandPull() == 0 && data.getLinkage() == 1) {
			buf.writeByte(0x01);
		} else if (data.getHandPull() == 1 && data.getLinkage() == 0) {
			buf.writeByte(0x10);
		} else if (data.getHandPull() == 1 && data.getLinkage() == 1) {
			buf.writeByte(0x11);
		}

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void queryWifiElectricMotorConfigurationInfo(ByteBuf buf,
			RequestConfigurationElectricMotorData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void queryWifiElectricMotorStatus(ByteBuf buf, RequestConfigurationElectricMotorData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void openOrCloseWifiCurtain(ByteBuf buf, RequestOpenOrCloseCurtainData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		buf.writeByte(data.getValue());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void stopOperatingWifiCurtain(ByteBuf buf, RequestOpenOrCloseCurtainData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void queryWifiCurtainPosition(ByteBuf buf, RequestOpenOrCloseCurtainData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void wifiCurtainStrokeControl(ByteBuf buf, RequestRollingBlindData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		buf.writeByte(data.getValue());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void deleteWifiStroke(ByteBuf buf, RequestRollingBlindData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x02);

		buf.writeBytes(data.getUid());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void addWifiTask(ByteBuf buf, RequestAddWifiTaskData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(data.getTaskType());

		try {
			buf.writeBytes(data.getTaskName().getBytes("gbk"));
			for (int i = 0; i < 32 - data.getTaskName().getBytes("gbk").length; i++) {
				buf.writeByte(0x00);
			}
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		buf.writeBytes(data.getUid());

		buf.writeByte(data.getMinute());

		buf.writeByte(data.getHour());

		buf.writeByte(data.getSecond());

		buf.writeByte(data.getWeek());

		buf.writeByte(data.getTstate());

		buf.writeByte(data.getCmd());

		buf.writeBytes(data.getData());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void deleteWifiTask(ByteBuf buf, RequestAddWifiTaskData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(data.getTaskId());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void updateWifiTask(ByteBuf buf, RequestAddWifiTaskData data) {
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(data.getTaskType());

		try {
			buf.writeBytes(data.getTaskName().getBytes("gbk"));
			for (int i = 0; i < 32 - data.getTaskName().getBytes("gbk").length; i++) {
				buf.writeByte(0x00);
			}
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		buf.writeByte(data.getTaskId());
		
		buf.writeBytes(data.getUid());

		buf.writeByte(data.getMinute());

		buf.writeByte(data.getHour());

		buf.writeByte(data.getSecond());

		buf.writeByte(data.getWeek());

		buf.writeByte(data.getTstate());

		buf.writeByte(data.getCmd());

		buf.writeBytes(data.getData());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void queryTheWifiTaskDetails(ByteBuf buf, RequestAddWifiTaskData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		buf.writeByte(0x00);
		
		buf.writeByte(data.getTaskId());

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

	public static void queryAllWifiTask(ByteBuf buf, RequestAddWifiTaskData data) {
		// TODO Auto-generated method stub
		buf.writeByte(0xFF);

		// total packets
		buf.writeByte(0x01);

		// Current packet
		buf.writeByte(0x01);

		// tbd 8 bytes
		for (int i = 0; i < 10; i++) {
			buf.writeByte(0x00);
		}
	}

}
