package com.b_noble.n_life.handler.processing;

import com.b_noble.n_life.event.IrControlTypeEnum;
import com.b_noble.n_life.event.WifiControlTypeEnum;

import io.netty.buffer.ByteBuf;

public class WifiHandlerProcessing {

	public static void processing(int responseType, ByteBuf buf, byte[] sn) {
		/**
		 * 获取模块信息
		 */
		if (responseType == WifiControlTypeEnum.GET_MODEL_INFORMATION.getVal()) {

			WifiHandlerProcessingRealization.getWifiModuleInformation(buf,sn);
		}
		/**
		 * 设置wifi信息
		 */
		if (responseType == WifiControlTypeEnum.SET_WIFIMODULE_WIFINETWORK_INFORMATION.getVal()) {

			WifiHandlerProcessingRealization.setWifiModuleWifiNetworkInformation(buf,sn);
		}
		
		/**
		 * 获取wifi信息
		 */
		if (responseType == WifiControlTypeEnum.REQUEST_WIFIMODULE_WIFINETWORK_INFORMATION.getVal()) {

			WifiHandlerProcessingRealization.requestWifiModuleWifiNetworkInformation(buf,sn);
		}
		
		/**
		 * 切换在线状态
		 */
		if (responseType == WifiControlTypeEnum.SWITCH_ONLINESTATE_OF_WIFIMODULE.getVal()) {

			WifiHandlerProcessingRealization.switchOnlineStateOfWifiModule(buf,sn);
		}
		
		/**
		 * 获取所有设备
		 */
		if (responseType == WifiControlTypeEnum.GET_MODULE_ALL_DEVICE.getVal()) {

			WifiHandlerProcessingRealization.getModuleAllDevice(buf,sn);
		}
		
		/**
		 * 获取版本
		 */
		if (responseType == WifiControlTypeEnum.REQUEST_WIFIMODULE_VERSION.getVal()) {

			WifiHandlerProcessingRealization.requestWifiModuleVersion(buf,sn);
		}
		
		/**
		 * 报告升级状态
		 */
		if (responseType == WifiControlTypeEnum.REPORT_UPGRADE_STATUS.getVal()) {

			WifiHandlerProcessingRealization.reportUpgradeStatus(buf,sn);
		}
		
		/**
		 * 将模块设置成网络模式
		 */
		if (responseType == WifiControlTypeEnum.SET_WIFIMODULE_INTOTHE_NETWORKMODE.getVal()) {

			WifiHandlerProcessingRealization.setWifiModuleIntoTheNetworkMode(buf,sn);
		}
		
		/**
		 * 设置设备开关状态
		 */
		if (responseType == WifiControlTypeEnum.SET_WIFI_DEVICE_SWITCHSTATE.getVal()) {

			WifiHandlerProcessingRealization.setWifiDeviceSwitchState(buf,sn);
		}
		
		/**
		 * 获取设备开关状态
		 */
		if (responseType == WifiControlTypeEnum.REQUIRE_WIFIDEVICE_SWITCHSTATE.getVal()) {

			WifiHandlerProcessingRealization.requireWifiDeviceSwitchState(buf,sn);
		}
		
		/**
		 * 设置灯的亮度
		 */
		if (responseType == WifiControlTypeEnum.SET_WIFILIGHT_BRIGHTNESS.getVal()) {

			WifiHandlerProcessingRealization.setWifiLightBrightness(buf,sn);
		}
		
		/**
		 * 获取灯的亮度
		 */
		if (responseType == WifiControlTypeEnum.REQUIRE_WIFILIGHT_BRIGHTNESS.getVal()) {

			WifiHandlerProcessingRealization.requireWifiLightBrightness(buf,sn);
		}
		
		
		/**
		 * 设置灯的色调饱和度
		 */
		if (responseType == WifiControlTypeEnum.SET_WIFILIGHTHUE_OR_SATURATION.getVal()) {

			WifiHandlerProcessingRealization.setWifiLighthueOrSaturation(buf,sn);
		}
		
		/**
		 * 获取灯的色调饱和度
		 */
		if (responseType == WifiControlTypeEnum.REQUIRE_WIFILIGHTHUE_OR_SATURATION.getVal()) {

			WifiHandlerProcessingRealization.requireWifiLighthueOrSaturation(buf,sn);
		}
		
		/**
		 * 设置灯的色温
		 */
		if (responseType == WifiControlTypeEnum.SET_WIFILIGHT_COLORTEMPERATURE.getVal()) {

			WifiHandlerProcessingRealization.setWifiLightColorTemperature(buf,sn);
		}
		/**
		 * 获取灯的色温
		 */
		if (responseType == WifiControlTypeEnum.REQUIRE_WIFILIGHT_COLORTEMPERATURE.getVal()) {

			WifiHandlerProcessingRealization.requireWifiLightColorTemperature(buf,sn);
		}
		
		/**
		 * 设置电机方向
		 */
		if (responseType == WifiControlTypeEnum.SET_WIFIELECTRICMOTOR_DIRECTION.getVal()) {

			WifiHandlerProcessingRealization.setWifiElectricMotorDirection(buf,sn);
		}
		
		/**
		 * 配置电动马达
		 */
		if (responseType == WifiControlTypeEnum.CONFIGURATION_WIFIELECTRIC_MOTOR.getVal()) {

			WifiHandlerProcessingRealization.configurationWifiElectricMotor(buf,sn);
		}
		
		/**
		 * 查询电机配置信息
		 */
		if (responseType == WifiControlTypeEnum.QUERY_WIFIELECTRIC_MOTOR_CONFIGURATIONINFO.getVal()) {

			WifiHandlerProcessingRealization.queryWifiElectricMotorConfigurationInfo(buf,sn);
		}
		
		/**
		 * 查询电机状态
		 */
		if (responseType == WifiControlTypeEnum.QUERY_WIFIELECTRIC_MOTOR_STATUS.getVal()) {

			WifiHandlerProcessingRealization.queryWifiElectricMotorStatus(buf,sn);
		}
		
		/**
		 * 打开或关闭窗帘
		 */
		if (responseType == WifiControlTypeEnum.OPEN_OR_CLOSE_WIFICURTAIN.getVal()) {

			WifiHandlerProcessingRealization.openOrCloseWifiCurtain(buf,sn);
		}
		
		/**
		 * 停止操作窗帘
		 */
		if (responseType == WifiControlTypeEnum.STOP_OPERATING_WIFICURTAIN.getVal()) {

			WifiHandlerProcessingRealization.stopOperatingWifiCurtain(buf,sn);
		}
		
		/**
		 * 查询窗帘位置
		 */
		if (responseType == WifiControlTypeEnum.QUERY_WIFICURTAIN_POSITION.getVal()) {

			WifiHandlerProcessingRealization.queryWifiCurtainPosition(buf,sn);
		}
		
		/**
		 * 卷帘行程控制
		 */
		if (responseType == WifiControlTypeEnum.CURTAIN_STROKE_CONTROL.getVal()) {

			WifiHandlerProcessingRealization.wifiCurtainStrokeControl(buf,sn);
		}
		
		/**
		 * 删除行程
		 */
		if (responseType == WifiControlTypeEnum.DELETE_WIFI_STROKE.getVal()) {

			WifiHandlerProcessingRealization.deleteWifiStroke(buf,sn);
		}
		
		/**
		 * 查询任务列表
		 */
		if (responseType == WifiControlTypeEnum.QUERY_ALL_TASKS.getVal()) {

			WifiHandlerProcessingRealization.queryAllWifiTask(buf,sn);
		}
		/**
		 * 查询任务详细
		 */
		if (responseType == WifiControlTypeEnum.QUERY_DETAILS_TASKS.getVal()) {

			WifiHandlerProcessingRealization.queryTheWifiTaskDetails(buf,sn);
		}
		/**
		 * 添加定时任务
		 */
		if (responseType == WifiControlTypeEnum.ADD_TASK.getVal()) {

			WifiHandlerProcessingRealization.addWifiTask(buf,sn);
		}
		/**
		 * 删除定时任务
		 */
		if (responseType == WifiControlTypeEnum.DELETE_TASK.getVal()) {

			WifiHandlerProcessingRealization.deleteWifiTask(buf,sn);
		}
		/**
		 * 修改定时任务
		 */
		if (responseType == WifiControlTypeEnum.UPDATE_TASK.getVal()) {

			WifiHandlerProcessingRealization.updateWifiTask(buf,sn);
		}
		
		
	}

}
