package com.b_noble.n_life.info;

import java.io.Serializable;
import java.util.Arrays;

import com.b_noble.n_life.utils.Test16Binary;

/**
 * @公司：深圳市中泰智丰物联网科技有限公司
 * @项目：智能家居
 * @简述：联动任务实体类
 * @作者：zhangfan 
 * @date：2016-08-04 
 * @版本：V0.0.1
 */
public class TaskDeviceAction implements Serializable
{

	private static final long serialVersionUID = -6788487849446346915L;
    
    private byte[] uId;
    private byte devType; //设备类型，对照表查询 DevTypeEnum

    private byte ruleMin; 	//最小触发至
    private byte ruleMax;	//最大触发值
    private byte ruleVal;	//真实值（等于）或状态

    
	public TaskDeviceAction() {
		super();
	}


	public byte[] getuId() {
		return uId;
	}


	public void setuId(byte[] uId) {
		this.uId = uId;
	}


	public byte getRuleMin() {
		return ruleMin;
	}


	public void setRuleMin(byte ruleMin) {
		this.ruleMin = ruleMin;
	}


	public byte getRuleMax() {
		return ruleMax;
	}


	public void setRuleMax(byte ruleMax) {
		this.ruleMax = ruleMax;
	}


	public byte getRuleVal() {
		return ruleVal;
	}


	public void setRuleVal(byte ruleVal) {
		this.ruleVal = ruleVal;
	}


	
	public byte getDevType() {
		return devType;
	}


	public void setDevType(byte devType) {
		this.devType = devType;
	}




	public TaskDeviceAction(byte[] uId, byte devType, byte ruleMin, byte ruleMax, byte ruleVal) {
		super();
		this.uId = uId;
		this.devType = devType;
		this.ruleMin = ruleMin;
		this.ruleMax = ruleMax;
		this.ruleVal = ruleVal;
	}


	@Override
	public String toString() {
		return "TaskDeviceAction [uId=" + Test16Binary.bytes2hex03(uId) + ", devType=" + devType + ", ruleMin=" + ruleMin
				+ ", ruleMax=" + ruleMax + ", ruleVal=" + ruleVal + "]";
	}



	

}
