package com.b_noble.n_life.utils;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.util.concurrent.CountDownLatch;

/**
 * @公司：深圳市中泰智丰物联网科技有限公司
 * @项目：智能家居
 * @简述：app向网关发送绑定指令（UDP方式广播） @作者：zhangfan @date：2016-10-14 @版本：V0.0.1
 */
public class BandingUdpUtils extends Thread {

	private static CountDownLatch threadsSignal;

	private static String sn;

	public BandingUdpUtils(CountDownLatch threadsSignal, String sn) {
		super();
		this.threadsSignal = threadsSignal;
		this.sn = sn;
	}

	@Override
	public void run() {
		BangdingUdp();
	}

	private void BangdingUdp() {
		MulticastSocket sender = null;
		DatagramPacket dataPacket = null;
		InetAddress group = null;
		String datas = "Request:Binding\r\nSN:" + sn + "\r\n";
		byte[] data = datas.getBytes();

		try {

			sender = new MulticastSocket();
			group = InetAddress.getByName("255.255.255.255");
			dataPacket = new DatagramPacket(data, data.length, group, 9181);

			sender.send(dataPacket);

			DatagramPacket receive = new DatagramPacket(new byte[1024], 1024);
			sender.receive(receive);
			String req = new String(receive.getData());

			System.out.println(req);
			Global.bingState = receive.getAddress().toString().substring(1, receive.getAddress().toString().length());
			

			threadsSignal.countDown();
			sender.close();

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	
	 /* private void BangdingUdp() { // TODO Auto-generated method stub final
	  NioEventLoopGroup nioEventLoopGroup = new NioEventLoopGroup(); try {
	  Bootstrap bootstrap = new Bootstrap();
	  bootstrap.channel(NioDatagramChannel.class);
	  bootstrap.group(nioEventLoopGroup); bootstrap.handler(new
	  BangdingHandler()); // 监听端口
	   ChannelFuture sync  =bootstrap.bind(0).sync();
	   Channel udpChannel = sync.channel();
	  
	  String data = "Request:Binding\r\nSN:" + sn + "\r\n";
	  udpChannel.writeAndFlush(new
	  DatagramPacket(Unpooled.copiedBuffer(data.getBytes(Charset.forName(
	  "UTF-8"))), new InetSocketAddress("255.255.255.255", 9181)));
	  
	  threadsSignal.countDown();
	  
	  udpChannel.closeFuture().sync();
	  
	  } catch (InterruptedException e) { e.printStackTrace(); } finally {
	  nioEventLoopGroup.shutdownGracefully(); } }*/
	 

}
