package com.b_noble.n_life.utils;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.MulticastSocket;
import java.nio.charset.Charset;
import java.util.concurrent.CountDownLatch;

import com.b_noble.n_life.handler.getGatewayHandler;


/**
 * @公司：深圳市中泰智丰物联网科技有限公司
 * @项目：智能家居
 * @简述：app搜索本地网关帮助类（UDP方式广播） @作者：zhangfan @date：2016-08-04 @版本：V0.0.1
 */
public class BroadcastUdpUtils extends Thread {

	private static CountDownLatch threadsSignal;

	public BroadcastUdpUtils(CountDownLatch threadsSignal) {
		super();
		this.threadsSignal = threadsSignal;
	}

	@Override
	public void run() {
		BroadcastUdp();
	}

	private void BroadcastUdp() {

		MulticastSocket sender = null;
		DatagramPacket dataPacket = null;
		InetAddress group = null;
		byte[] data = "ZTZF_Gateway\r\n".getBytes();

		try {

			sender = new MulticastSocket();
			group = InetAddress.getByName("255.255.255.255");
			dataPacket = new DatagramPacket(data, data.length, group, 9188);

			sender.send(dataPacket);

			for (int i = 0; i < 100; i++) {
				
				DatagramPacket receive = new DatagramPacket(new byte[1024], 1024);
				sender.receive(receive);
				String req = new String(receive.getData());
				System.out.println(req+"---"+receive.getAddress().getHostAddress());
				try {
					Global.ips.put(receive.getAddress().toString(), req.split(":")[1] + "#" + req.split(":")[2].subSequence(0, 1));
				} catch (Exception e) {
					Global.ips.put(receive.getAddress().toString(), req.split(":")[1].subSequence(0, 8) + "#1");
				}
				
			}
			threadsSignal.countDown();
			sender.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/*private void NettyBroadcastUdp() {
		// TODO Auto-generated method stub
		final NioEventLoopGroup nioEventLoopGroup = new NioEventLoopGroup();
		try {
			Bootstrap bootstrap = new Bootstrap();
			bootstrap.channel(NioDatagramChannel.class);
			bootstrap.group(nioEventLoopGroup);
			bootstrap.handler(new getGatewayHandler());
			// 监听端口
			ChannelFuture sync = bootstrap.bind(0).sync();
			Channel udpChannel = sync.channel();

			String data = "ZTZF_Gateway\r\n";
			udpChannel.writeAndFlush(new DatagramPacket(Unpooled.copiedBuffer(data.getBytes(Charset.forName("UTF-8"))),
					new InetSocketAddress("255.255.255.255", 9188)));

			threadsSignal.countDown();

			udpChannel.closeFuture().sync();

		} catch (InterruptedException e) {
			e.printStackTrace();
		} finally {
			nioEventLoopGroup.shutdownGracefully();
		}
	}*/
}
