package com.b_noble.n_life.utils;

import com.b_noble.n_life.event.DeviceTypeEnum;

/**
 * @公司：深圳市中泰智丰物联网科技有限公司
 * @项目：智能家居
 * @简述：设备类型帮助类
 * @作者：zhangfan 
 * @date：2016-08-04 
 * @版本：V0.0.1
 */
public class DeviceTypeUtils {

	public static int getDeviceType(byte[] deviceId, byte[] ProfileId) {
		String did = Test16Binary.bytes2hex03(deviceId).replaceAll(" ", "");

		String fid = Test16Binary.bytes2hex03(ProfileId).replaceAll(" ", "");

		/**
		 * 扩展 RGB 灯
		 */
		if (fid.equals("c05e") && (did.equals("0000") || did.equals("0010")
				|| did.equals("0100") || did.equals("0110") || did.equals("0200")
				|| did.equals("0210")  )) {
			return DeviceTypeEnum.RGB_LIGTH.getVal();
		}
		
		/**
		 * CT 灯
		 */
		if (fid.equals("c05e") && did.equals("0220")) {
			return DeviceTypeEnum.CT_LIGTH.getVal();
		}

		/**
		 * 传感器
		 */
		  if (fid.equals("0104") && did.equals("0402")) { 
			  return  DeviceTypeEnum.SENSOR.getVal(); 
		  }
		 
		/**
		 * 插座
		 */
		if (fid.equals("0104") && did.equals("0009")) {
			return DeviceTypeEnum.MAINSPOWEROUTLET.getVal();
		}
		
		/**
		 * 智能插座
		 */
		if (fid.equals("0104") && did.equals("0051")) {
			return DeviceTypeEnum.ZMAINSPOWEROUTLET.getVal();
		}
		
		/**
		 * 温度湿度传感器
		 */
		if (fid.equals("0104") && did.equals("0302")) {
			return DeviceTypeEnum.TEMPERATURE_HUMIDITY.getVal();
		}
		/**
		 * 开关面板
		 */
		if (fid.equals("0104") && did.equals("0002")) {
			return DeviceTypeEnum.MECHANICALHANDLE.getVal();
		}
		
		/**
		 * 窗帘
		 */
		if (fid.equals("0104") && did.equals("0200")) {
			return DeviceTypeEnum.CURTAIN.getVal();
		}
		
		/**
		 * 智能门锁
		 */
		if (fid.equals("0104") && did.equals("000a")) {
			return DeviceTypeEnum.DOORLOCK.getVal();
		}
		
		/**
		 * 红外遥控器
		 */
		if (fid.equals("1111") && did.equals("2222")) {
			return DeviceTypeEnum.IR.getVal();
		}
		/**
		 * 红外遥控器
		 */
		if (fid.equals("3333") && did.equals("4444")) {
			return DeviceTypeEnum.IR_REMOTE_CONTROL.getVal();
		}
		/**
		 * 情景面板
		 */
		if (fid.equals("0104") && did.equals("0004")) {
			return DeviceTypeEnum.SCENE_PANEL.getVal();
		}
		/**
		 * 温控器
		 */
		if (fid.equals("0104") && did.equals("0301")) {
			return DeviceTypeEnum.THERMOSTAT.getVal();
		}
		
		/**
		 * 窗帘面板
		 */
		if (fid.equals("0104") && did.equals("0202")) {
			return DeviceTypeEnum.CURTAIN_PANEL.getVal();
		}
		
		/**
		 * 报警器
		 */
		if (fid.equals("0104") && did.equals("0403")) {
			return DeviceTypeEnum.ALARM.getVal();
		}
		
		/**
		 * 未知设备
		 */
		else {
			return DeviceTypeEnum.UNKNOWN.getVal();
		}

	}
}
