package com.b_noble.n_life.utils;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;
import java.net.URLConnection;
import java.util.List;
import java.util.Map;

public class HttpRequest {

	/**
	 * 向指定URL发送GET方法的请求
	 * 
	 * @param url
	 *            发送请求的URL
	 * @param param
	 *            请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
	 * @return URL 所代表远程资源的响应结果
	 */
	public static String sendGet(String url, String param) throws Exception {
		String result = "";
		BufferedReader in = null;
		String urlNameString = url + "?" + param;
		URL realUrl = new URL(urlNameString);
		// 打开和URL之间的连接
		URLConnection connection = realUrl.openConnection();
		// 设置通用的请求属性
		connection.setRequestProperty("accept", "*/*");
		connection.setRequestProperty("connection", "Keep-Alive");
		connection.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
		connection.setReadTimeout(5000);
		connection.setConnectTimeout(5000);
		// 建立实际的连接`
		connection.connect();
		// 获取所有响应头字段
		Map<String, List<String>> map = connection.getHeaderFields();
		// 遍历所有的响应头字段
		for (String key : map.keySet()) {
			System.out.println(key + "--->" + map.get(key));
		}
		// 定义 BufferedReader输入流来读取URL的响应
		in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
		String line;
		while ((line = in.readLine()) != null) {
			result += line;
		}
		return result;
	}

	/**
	 * 向指定 URL 发送POST方法的请求
	 * 
	 * @param url
	 *            发送请求的 URL
	 * @param param
	 *            请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
	 * @return 所代表远程资源的响应结果
	 */
	public static String sendPost(String url, String param) throws Exception {
		PrintWriter out = null;
		BufferedReader in = null;
		String result = "";
		URL realUrl = new URL(url);
		// 打开和URL之间的连接
		URLConnection conn = realUrl.openConnection();
		// 设置通用的请求属性
		conn.setRequestProperty("accept", "*");
		conn.setRequestProperty("connection", "Keep-Alive");
		conn.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");

		long date = System.currentTimeMillis();
		String username = "18629578889";
		String userpassword = "a123456";
		String finallString = username + "," + userpassword + "," + date;
		String aes = SymmetricEncoder.aesEncryptString(finallString, SymmetricEncoder.AES);
		conn.setRequestProperty("code", aes);
		
		conn.setRequestProperty("token","eyJleHAiOjE1MTEzMzU4NTMxMzMsInBheWxvYWQiOiJ7XCJ1c2VySWRcIjo2MDcsXCJwYXNzd29yZFwiOlwiWWtacWIwaFpObWxZTTFoSVIwOTBZV0o1YTJWdFp6MDlcIixcInVzZXJOYW1lXCI6XCIxMzU2MDcyMzYwM1wiLFwiY3VycmVudFRpbWVNaWxsaXNcIjpudWxsfSJ9");
		
		// 发送POST请求必须设置如下两行
		conn.setDoOutput(true);
		conn.setDoInput(true);
		conn.setReadTimeout(5000);
		conn.setConnectTimeout(5000);
		// 获取URLConnection对象对应的输出流
		out = new PrintWriter(conn.getOutputStream());
		// 发送请求参数
		out.print(param);
		// flush输出流的缓冲
		out.flush();
		// 定义BufferedReader输入流来读取URL的响应
		in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		String line;
		while ((line = in.readLine()) != null) {
			result += line;
		}
		return result;
	}

	/**
	 * 基于Apache的HttpClient包接口调用
	 * 
	 * @return
	 */
	/*
	 * public static String sendPost(String url, String param) {
	 * 
	 * String result = "";
	 * 
	 * // 创建默认的httpClient实例 CloseableHttpClient httpclient =
	 * HttpClients.createDefault(); // 创建httppost HttpPost hpost = new
	 * HttpPost(url); // 创建参数队列 List<NameValuePair> formparams = new
	 * ArrayList<NameValuePair>();
	 * 
	 * 
	 * Map<String, String> map = new HashMap<String, String>(); String[] str =
	 * param.split("&");
	 * 
	 * for (int i = 0; i < str.length; i++) { String pa = str[i]; String[] p =
	 * pa.split("="); map.put(p[0], p[1]); formparams.add(new
	 * BasicNameValuePair(p[0], p[1])); }
	 * 
	 * 
	 * UrlEncodedFormEntity uefEntity; try { // 设置编码格式 uefEntity = new
	 * UrlEncodedFormEntity(formparams, "UTF-8"); // 设置请求参数
	 * hpost.setEntity(uefEntity); System.out.println("executing request " +
	 * hpost.getURI()); // 发送post请求并返回一个HttpResponse对象 CloseableHttpResponse
	 * response = httpclient.execute(hpost); try { //
	 * 获取HttpEntity对象，该对象包装了服务器的响应内容 HttpEntity entity = response.getEntity();
	 * if (entity != null) { result = EntityUtils.toString(entity, "UTF-8"); } }
	 * finally { response.close(); } } catch (ClientProtocolException e) {
	 * e.printStackTrace(); } catch (UnsupportedEncodingException e1) {
	 * e1.printStackTrace(); } catch (IOException e) { e.printStackTrace(); }
	 * finally { // 关闭连接,释放资源 try { httpclient.close(); } catch (IOException e)
	 * { e.printStackTrace(); } } return result; }
	 */

	public static void main(String[] args) throws Exception {

		/*String result = HttpRequest.sendPost(
				"http://vooct.com:8080/manaplatform/mobileTerminal_http/userImfraedBinding",
				"loginName=15991615037&sn=ZR1F8106");*/
		/*String result = HttpRequest.sendPost(
				"http://47.92.36.104:8080/manaplatform/mobileTerminal_http/generateDeviceSnCode",
				"deviceType=W&token=EF950415106DD6E0A079C6FE2CFCAAEA");*/
		
		//String result = HttpRequest.sendPost("http://120.76.223.218:8080/manaplatform/mobileTerminal_http/userDeviceBinding", "loginName=15991615037&sn=ZTB2R412&name=ZTB2R412&uType=T");
		//String result = HttpRequest.sendPost("http://47.92.36.104:8080/manaplatform/mobileTerminal_http/generateDeviceSnCode", "deviceType=T&token=EF950415106DD6E0A079C6FE2CFCAAEA");
		//HttpRequest.sendPost("http://120.76.223.218:8080/manaplatform/mobileTerminal_http/findSpace","loginName=15991615037&sn=ZTPRR410" );
		String result = HttpRequest.sendPost("http://47.92.36.104:8000/doorlock", "m=addDoorlockUser&sn=ZTN88P27&rcid=111,191,64&lockUserInfo={'permission':3,'name':'房客22','password':'155555','effectiveTime':'17,12,2,18,0,0,17,12,9,11,30,30','unlockNumber':2}");
		//String result = HttpRequest.sendPost("http://47.92.36.104:8000/doorlock", "m=setDoorlockState&sn=ZTN88P27&rcid=161,117,64&state=1");
		//String result = HttpRequest.sendPost("http://47.92.36.104:8000/doorlock", "m=modifyDoorlockUserPasswd&sn=ZT43YL4S&rcid=203,191,64&permission=3&name=房客3&newpassword=24242424&effectiveTime=17,10,17,18,0,0,17,10,28,11,30,30");
		//String result = HttpRequest.sendPost("http://47.92.36.104:8000/doorlock", "m=freezeDoorlockUser&sn=ZT9DIS4V&rcid=113,29,64&permission=3&name=房客5&freeze=1");
		//String result = HttpRequest.sendPost("http://47.92.36.104:8000/doorlock", "m=deleteGyDoorlockUser&sn=ZT28SZ0E&rcid=113,29,64&permission=3&name=房客4");
		
		//String result = HttpRequest.sendPost("http://47.92.36.104:8080/manaplatform/mobileTerminal_http/getDeviceSubByLoginName","loginName=15991615037");
	//	String result = HttpRequest.sendPost("http://www.sojson.com/open/api/weather/json.shtml","city=北京");
		System.out.println(result);

	}
}
